(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('lodash'), require('rxjs'), require('rxjs/operators'), require('@angular/material/dialog'), require('@angular/animations'), require('rxjs/ajax'), require('@aws-sdk/client-cognito-identity'), require('@aws-sdk/client-s3'), require('@aws-sdk/credential-provider-cognito-identity'), require('@aws-sdk/middleware-retry'), require('uuid'), require('@angular/common/http'), require('@angular/material/button'), require('@angular/material/icon'), require('@angular/material/progress-bar'), require('@angular/material/table'), require('@angular/material/tooltip'), require('react'), require('@uiw/react-tooltip'), require('@codesandbox/sandpack-react'), require('@uiw/react-split'), require('@codingame/monaco-editor-react'), require('@stitches/core'), require('vscode-material-icon-theme-js'), require('@codingame/monaco-editor-wrapper/features/typescriptContribution'), require('@codingame/monaco-editor-wrapper/features/jsonContribution'), require('@codingame/monaco-editor-wrapper/features/cssContribution'), require('@codingame/monaco-editor-wrapper/features/htmlContribution'), require('react-select/async'), require('mustache'), require('react-select'), require('@angular/material/progress-spinner'), require('react-dom/client')) :
    typeof define === 'function' && define.amd ? define('@opencoders/codejudge', ['exports', '@angular/core', '@angular/common', 'lodash', 'rxjs', 'rxjs/operators', '@angular/material/dialog', '@angular/animations', 'rxjs/ajax', '@aws-sdk/client-cognito-identity', '@aws-sdk/client-s3', '@aws-sdk/credential-provider-cognito-identity', '@aws-sdk/middleware-retry', 'uuid', '@angular/common/http', '@angular/material/button', '@angular/material/icon', '@angular/material/progress-bar', '@angular/material/table', '@angular/material/tooltip', 'react', '@uiw/react-tooltip', '@codesandbox/sandpack-react', '@uiw/react-split', '@codingame/monaco-editor-react', '@stitches/core', 'vscode-material-icon-theme-js', '@codingame/monaco-editor-wrapper/features/typescriptContribution', '@codingame/monaco-editor-wrapper/features/jsonContribution', '@codingame/monaco-editor-wrapper/features/cssContribution', '@codingame/monaco-editor-wrapper/features/htmlContribution', 'react-select/async', 'mustache', 'react-select', '@angular/material/progress-spinner', 'react-dom/client'], factory) :
    (global = typeof globalThis !== 'undefined' ? globalThis : global || self, factory((global.opencoders = global.opencoders || {}, global.opencoders.codejudge = {}), global.ng.core, global.ng.common, global.lodash, global.rxjs, global.rxjs.operators, global.ng.material.dialog, global.ng.animations, global.rxjs.ajax, global.clientCognitoIdentity, global.clientS3, global.credentialProviderCognitoIdentity, global.middlewareRetry, global.uuid, global.ng.common.http, global.ng.material.button, global.ng.material.icon, global.ng.material.progressBar, global.ng.material.table, global.ng.material.tooltip, global.React, global.Tooltip, global.sandpackReact, global.Split, global.Editor, global.core, global.vscodeMaterialIconThemeJs, null, null, null, null, global.AsyncSelect, global.Mustache, global.Select, global.ng.material.progressSpinner, global.client));
})(this, (function (exports, i0, i7, lodash, rxjs, operators, i2, animations, ajax, clientCognitoIdentity, clientS3, credentialProviderCognitoIdentity, middlewareRetry, uuid, i1, i3, i4, i5, i6, i8, React, Tooltip, sandpackReact, Split, Editor, core, vscodeMaterialIconThemeJs, typescriptContribution, jsonContribution, cssContribution, htmlContribution, AsyncSelect, Mustache, Select, i2$1, client) { 'use strict';

    function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

    function _interopNamespace(e) {
        if (e && e.__esModule) return e;
        var n = Object.create(null);
        if (e) {
            Object.keys(e).forEach(function (k) {
                if (k !== 'default') {
                    var d = Object.getOwnPropertyDescriptor(e, k);
                    Object.defineProperty(n, k, d.get ? d : {
                        enumerable: true,
                        get: function () { return e[k]; }
                    });
                }
            });
        }
        n["default"] = e;
        return Object.freeze(n);
    }

    var i0__namespace = /*#__PURE__*/_interopNamespace(i0);
    var i7__namespace = /*#__PURE__*/_interopNamespace(i7);
    var i2__namespace = /*#__PURE__*/_interopNamespace(i2);
    var i1__namespace = /*#__PURE__*/_interopNamespace(i1);
    var i3__namespace = /*#__PURE__*/_interopNamespace(i3);
    var i4__namespace = /*#__PURE__*/_interopNamespace(i4);
    var i5__namespace = /*#__PURE__*/_interopNamespace(i5);
    var i6__namespace = /*#__PURE__*/_interopNamespace(i6);
    var i8__namespace = /*#__PURE__*/_interopNamespace(i8);
    var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
    var React__namespace = /*#__PURE__*/_interopNamespace(React);
    var Tooltip__default = /*#__PURE__*/_interopDefaultLegacy(Tooltip);
    var Split__default = /*#__PURE__*/_interopDefaultLegacy(Split);
    var Editor__default = /*#__PURE__*/_interopDefaultLegacy(Editor);
    var AsyncSelect__default = /*#__PURE__*/_interopDefaultLegacy(AsyncSelect);
    var Mustache__default = /*#__PURE__*/_interopDefaultLegacy(Mustache);
    var Select__default = /*#__PURE__*/_interopDefaultLegacy(Select);
    var i2__namespace$1 = /*#__PURE__*/_interopNamespace(i2$1);

    var ifFadeInAnimation = animations.trigger('ifFadeInAnimation', [
        animations.transition(':enter', [
            animations.style({ height: 0, opacity: 0, visibility: 'hidden', overflow: 'hidden' }),
            animations.animate('300ms ease-out', animations.style({ height: '*', opacity: 1, visibility: 'visible' }))
        ]),
        animations.transition(':leave', [
            animations.style({ height: '*', opacity: 1, visibility: 'visible' }),
            animations.animate('300ms ease-in', animations.style({ height: 0, opacity: 0, visibility: 'hidden' }))
        ])
    ]);
    var fadeInAnimation = animations.trigger('fadeInAnimation', [
        animations.state('collapsed, void', animations.style({ height: '0px', visibility: 'hidden', opacity: 0, overflow: 'hidden' })),
        animations.state('expanded', animations.style({ height: '*', visibility: 'visible', opacity: 1 })),
        animations.transition('expanded <=> collapsed, void => collapsed', animations.animate('300ms cubic-bezier(0.4, 0.0, 0.2, 1)')),
    ]);
    var rotateAnimation = animations.trigger('rotateAnimation', [
        animations.state('true', animations.style({ transform: 'rotate(0)' })),
        animations.state('false', animations.style({ transform: 'rotate(180deg)' })),
        animations.transition('true => false', animations.animate('300ms ease-out')),
        animations.transition('false => true', animations.animate('300ms ease-in'))
    ]);
    var rotateAnimation90 = animations.trigger('rotateAnimation90', [
        animations.state('true', animations.style({ transform: 'rotate(0)' })),
        animations.state('false', animations.style({ transform: 'rotate(90deg)' })),
        animations.transition('true => false', animations.animate('300ms ease-out')),
        animations.transition('false => true', animations.animate('300ms ease-in'))
    ]);

    var stringToUUID = function (value) {
        var uuid = value.substr(0, 8) + '-' +
            value.substr(8, 4) + '-' +
            value.substr(12, 4) + '-' +
            value.substr(16, 4) + '-' +
            value.substr(20);
        return uuid;
    };
    var isValidUUID = function (value) {
        if (uuid.validate(value)) {
            return true;
        }
        return uuid.validate(stringToUUID(value));
    };
    var AWS = /** @class */ (function () {
        function AWS() {
        }
        AWS.initialize = function (environment) {
            this.environment = environment;
            var retryStrategy = new middlewareRetry.StandardRetryStrategy(function () { return Promise.resolve(10); }, { delayDecider: function (_delayBase, attempts) { return 2 ^ (attempts * 100); } });
            retryStrategy.mode = 'STANDARD';
            this.s3Client = new clientS3.S3Client({
                region: environment.aws_upload.region,
                credentials: credentialProviderCognitoIdentity.fromCognitoIdentityPool({
                    client: new clientCognitoIdentity.CognitoIdentityClient({ region: environment.aws_upload.region }),
                    identityPoolId: environment.aws_upload.identityPoolId
                }),
                retryStrategy: retryStrategy,
            });
        };
        AWS.uploadFiles = function (options) {
            var _this = this;
            var obs = [];
            options.forEach(function (option) { return obs.push(_this.uploadFile(option)); });
            return rxjs.forkJoin(obs);
        };
        AWS.uploadFile = function (options) {
            var _this = this;
            var file = options.file, path = options.path, name = options.name, _a = options.unique, unique = _a === void 0 ? true : _a, _b = options.root, root = _b === void 0 ? false : _b;
            if (unique) {
                name = Date.now() + "--" + uuid.v4() + "--" + name;
            }
            var Key = (path + "/" + name).replace(/(null|undefined)+/g, '').split('/').filter(Boolean).join('/');
            if (!isValidUUID(Key.split('/')[0])) {
                Key = "codejudge-s3-cognito/" + Key;
            }
            var uploadParams = new clientS3.PutObjectCommand({
                Bucket: this.environment.aws_upload.aws_bucket,
                Key: Key,
                Body: file,
                ACL: this.environment.aws_upload.access_acl,
            });
            return rxjs.from(this.s3Client.send(uploadParams)).pipe(operators.map(function (res) { return ({
                url: "https://" + _this.environment.aws_upload.aws_bucket + ".s3.us-east-1.amazonaws.com/" + Key,
                fileName: name,
            }); }));
        };
        return AWS;
    }());

    function pollWhile(isPollingActive, emitOnlyLast, time, maxAttempts, maxDelay, callback) {
        if (emitOnlyLast === void 0) { emitOnlyLast = false; }
        if (maxAttempts === void 0) { maxAttempts = 10; }
        if (maxDelay === void 0) { maxDelay = 10; }
        var dueTime = (typeof time === 'number' ? time : time.dueTime) * 1000;
        var period = (typeof time === 'number' ? time : time.period) * 1000;
        maxDelay = maxDelay * 1000;
        var count = 0;
        return function (source$) {
            var poll$ = rxjs.of({}).pipe(operators.tap(function () { return ++count; }), operators.map(function () { return count === 1 ? dueTime : Math.min(period * Math.pow(1.5, count), maxDelay); }), operators.mergeMap(function (delay) { return rxjs.timer(delay); }), operators.switchMapTo(source$), operators.repeat(), operators.takeWhile(isPollingActive, true), operators.take(maxAttempts), operators.tap(function (res) { return callback === null || callback === void 0 ? void 0 : callback(res); }));
            return emitOnlyLast ? poll$.pipe(operators.last()) : poll$;
        };
    }
    var resolvablePromise = function () {
        var resolve;
        var reject;
        var promise = new Promise(function (_resolve, _reject) {
            resolve = _resolve;
            reject = _reject;
        });
        promise.resolve = resolve;
        promise.reject = reject;
        return promise;
    };
    function runInZone(zone) {
        return function (source) {
            return new rxjs.Observable(function (observer) {
                var onNext = function (value) { return zone.run(function () { return observer.next(value); }); };
                var onError = function (e) { return zone.run(function () { return observer.error(e); }); };
                var onComplete = function () { return zone.run(function () { return observer.complete(); }); };
                return source.subscribe(onNext, onError, onComplete);
            });
        };
    }

    var fetchFromUrl = function (urlOrRequest) {
        return ajax.ajax(urlOrRequest).pipe(operators.map(function (response) { return response.response; }));
    };

    var USER_TYPE = {
        RECRUITER: 'RECRUITER',
        DEVELOPER: 'DEVELOPER',
    };
    var PORTAL = {
        RECRUITER: 'RECRUITER',
        DEVELOPER: 'DEVELOPER',
        INTERVIEW: 'INTERVIEW',
    };
    exports.Constants = void 0;
    (function (Constants) {
        Constants["TEST"] = "TEST";
        Constants["CONTEST"] = "CONTEST";
    })(exports.Constants || (exports.Constants = {}));

    var ApiService = /** @class */ (function () {
        function ApiService(http, environment) {
            this.http = http;
            this.environment = environment;
        }
        ApiService.prototype.saveLiveRun = function (question, uuid, testType, language_id, workspace_url, portal) {
            var body = {
                "test_uuid": uuid,
                "test_type": testType,
                "question_id": question.id,
                "language_id": language_id,
                "question_type": question.type,
                "workspace_url": workspace_url
            };
            if (portal === PORTAL.RECRUITER) {
                body = {
                    "id": question.id,
                    "optionIds": question.exercises.map(function (x) { return x.id; }),
                    "workspaceUrl": workspace_url
                };
                return this.http.post(this.environment.coreApiUrl + 'question-builder/front-end/recruiter/evaluate', body).pipe(operators.map(function (res) { return res.response; }));
            }
            return this.http.post(this.environment.developerApiUrl + '/api/v6/execute-test-cases/async/', body);
        };
        ApiService.prototype.saveSubmission = function (question, uuid, testType, language_id, workspace_url, portal) {
            var body = {
                "test_uuid": uuid,
                "test_type": testType,
                "question_id": question.id,
                "language_id": language_id,
                "question_type": question.type,
                "project_code_url": workspace_url,
                "single_sub": true
            };
            return this.http.post(this.environment.developerApiUrl + '/api/v1/runs-v3/', body);
        };
        ApiService.prototype.getLiveRunStatus = function (id, portal, callback) {
            var _this = this;
            if (portal === PORTAL.RECRUITER) {
                return this.getSubmisssionStatus(id, callback);
            }
            var params = new i1.HttpParams()
                .set('id', id === null || id === void 0 ? void 0 : id.toString());
            return (this.http.get(this.environment.developerApiUrl + '/api/v1/live-run-result/id/', { params: params })).pipe(operators.map(function (res) { return (Object.assign(Object.assign({}, res.response.live_run), { output: _this.transformResults(res.response.live_run.output) })); }), pollWhile(function (result) { return result.status <= 2; }, true, 2, 20, undefined, callback), operators.mergeMap(function (result) { return _this.transformLogs(result); }));
        };
        ApiService.prototype.getSubmisssionStatus = function (id, callback) {
            var _this = this;
            var params = new i1.HttpParams()
                .set('id', id === null || id === void 0 ? void 0 : id.toString());
            return (this.http.get(this.environment.developerApiUrl + '/api/v1/submission_result/', { params: params })).pipe(operators.map(function (res) { return (Object.assign(Object.assign({}, res.run), { output: _this.transformResults(res.run.result_metadata) })); }), pollWhile(function (result) { return result.status <= 2; }, true, 2, 20, undefined, callback), operators.mergeMap(function (result) { return _this.transformLogs(result); }));
        };
        ApiService.prototype.transformResults = function (results) {
            results = results ? JSON.parse(results) : [];
            results = results.map(function (exercise) {
                exercise.output = exercise.output ? JSON.parse(exercise.output) : [];
                return exercise;
            });
            return results;
        };
        ApiService.prototype.transformLogs = function (result) {
            var obs;
            if ((result === null || result === void 0 ? void 0 : result.logs_file) || (result === null || result === void 0 ? void 0 : result.app_logs_file)) {
                obs = fetchFromUrl({ url: (result === null || result === void 0 ? void 0 : result.logs_file) || (result === null || result === void 0 ? void 0 : result.app_logs_file), responseType: 'text' }).pipe(operators.map(function (logs) { return (Object.assign(Object.assign({}, result), { logs: logs })); }));
            }
            else {
                result.logs = result.application_logs || result.logs || result.app_logs;
                obs = rxjs.of(result);
            }
            return obs;
        };
        return ApiService;
    }());
    ApiService.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: ApiService, deps: [{ token: i1__namespace.HttpClient }, { token: 'environment' }], target: i0__namespace.ɵɵFactoryTarget.Injectable });
    ApiService.ɵprov = i0__namespace.ɵɵngDeclareInjectable({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: ApiService, providedIn: 'root' });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: ApiService, decorators: [{
                type: i0.Injectable,
                args: [{
                        providedIn: 'root'
                    }]
            }], ctorParameters: function () {
            return [{ type: i1__namespace.HttpClient }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: ['environment']
                        }] }];
        } });
    var sample_data1 = {
        "run": {
            "id": 5352,
            "updated_at": "2022-05-11T02:12:08.771532Z",
            "created_at": "2022-05-11T02:12:08.771601Z",
            "user_id": 8,
            "question_id": 1553,
            "git_url": "https://github.com/devjudge/test-1553-q-32a146808a7544ecaa64699f2dc2aabf-8-express4.17.1-in-docker-2.git",
            "code": null,
            "endpoint": null,
            "repo_id": "NODE-10-EXP-4.17.1",
            "commit_id": "e1e1c78aa3750d426339efafd2c2b1ef9b713f6a",
            "branch": "master",
            "env_list": "",
            "run_type": "Server",
            "project_root": "",
            "test_uuid": "32a14680-8a75-44ec-aa64-699f2dc2aabf",
            "status": 4,
            "discrepancy_status": 1,
            "discrepancies": "{\"options\": []}",
            "result_metadata": "[{\"output\": \"\", \"test_case_score\": 20.0, \"status\": \"True\", \"points\": 20.0, \"test_case_id\": 21752, \"testCaseName\": \"Fetch a lead\"}, {\"output\": \"[{\\\"testCaseId\\\": 0, \\\"testCaseName\\\": \\\"Add a new Lead - Test 1\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testResponseCode\\\": 201}, {\\\"testCaseId\\\": 1, \\\"testCaseName\\\": \\\"Add a new Lead - Test 2\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testResponseCode\\\": 400}, {\\\"testCaseId\\\": 2, \\\"testCaseName\\\": \\\"Add a new Lead - Test 3\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testResponseCode\\\": 400}, {\\\"testCaseId\\\": 3, \\\"testCaseName\\\": \\\"Add a new Lead - Test 4\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testResponseCode\\\": 201}, {\\\"testCaseId\\\": 4, \\\"testCaseName\\\": \\\"Check created Lead - Test 1\\\", \\\"testCaseResultStatus\\\": \\\"FAILED\\\", \\\"testCaseExceptionMessage\\\": \\\"Extractor threw exception: Not legal JSON!\\\", \\\"testResponseCode\\\": \\\"Traceback (most recent call last):\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 239, in extract_internal\\\\n    body = json.loads(body)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/__init__.py\\\\\\\", line 354, in loads\\\\n    return _default_decoder.decode(s)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/decoder.py\\\\\\\", line 339, in decode\\\\n    obj, end = self.raw_decode(s, idx=_w(s, 0).end())\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/decoder.py\\\\\\\", line 357, in raw_decode\\\\n    raise JSONDecodeError(\\\\\\\"Expecting value\\\\\\\", s, err.value) from None\\\\njson.decoder.JSONDecodeError: Expecting value: line 1 column 1 (char 0)\\\\n\\\\nDuring handling of the above exception, another exception occurred:\\\\n\\\\nTraceback (most recent call last):\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 358, in validate\\\\n    body=body, headers=headers, context=context)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 185, in extract\\\\n    return self.extract_internal(query=query, body=body, headers=headers, args=self.args)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 242, in extract_internal\\\\n    raise ValueError(\\\\\\\"Not legal JSON!\\\\\\\")\\\\nValueError: Not legal JSON!\\\\n\\\"}, {\\\"testCaseId\\\": 5, \\\"testCaseName\\\": \\\"Check created Lead - Test 2\\\", \\\"testCaseResultStatus\\\": \\\"FAILED\\\", \\\"testCaseExceptionMessage\\\": \\\"Extractor threw exception: Not legal JSON!\\\", \\\"testResponseCode\\\": \\\"Traceback (most recent call last):\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 239, in extract_internal\\\\n    body = json.loads(body)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/__init__.py\\\\\\\", line 354, in loads\\\\n    return _default_decoder.decode(s)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/decoder.py\\\\\\\", line 339, in decode\\\\n    obj, end = self.raw_decode(s, idx=_w(s, 0).end())\\\\n  File \\\\\\\"/usr/local/lib/python3.6/json/decoder.py\\\\\\\", line 357, in raw_decode\\\\n    raise JSONDecodeError(\\\\\\\"Expecting value\\\\\\\", s, err.value) from None\\\\njson.decoder.JSONDecodeError: Expecting value: line 1 column 1 (char 0)\\\\n\\\\nDuring handling of the above exception, another exception occurred:\\\\n\\\\nTraceback (most recent call last):\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 358, in validate\\\\n    body=body, headers=headers, context=context)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 185, in extract\\\\n    return self.extract_internal(query=query, body=body, headers=headers, args=self.args)\\\\n  File \\\\\\\"/usr/local/lib/python3.6/site-packages/pyresttest-1.7.2.dev0-py3.6.egg/pyresttest/validators.py\\\\\\\", line 242, in extract_internal\\\\n    raise ValueError(\\\\\\\"Not legal JSON!\\\\\\\")\\\\nValueError: Not legal JSON!\\\\n\\\"}]\", \"status\": \"False\", \"test_case_score\": 13, \"points\": 20.0, \"test_case_id\": 21753, \"testCaseName\": \"Generate a lead\"}]",
            "score": 33,
            "total_score": 40,
            "quality": 100,
            "logs": "",
            "logs_file": "",
            "application_logs": "",
            "app_logs_file": "https://codejudge-results-dev-dev.s3.amazonaws.com/run-5352-ac52e3ebb083479ea934701c9f1f8fa9-app-logs.txt",
            "passed_tests": 1,
            "language_id": 328,
            "test_type": "TEST",
            "project_zip": "s3://codejudge-results-dev-dev/5352-1553-8.zip",
            "project_zip_v2": "https://codejudge-results-dev-dev.s3.amazonaws.com/5352-1553-8--c92343dce0a64cb798d66c3ef9361fcf.zip",
            "build_zip": null,
            "pdf_uploaded": true,
            "plagiarism_status": null,
            "comparison": "",
            "retry_at": null,
            "retry_count": 0,
            "sonar_retry_at": null,
            "sonar_retry_count": 0,
            "files_changed": 6,
            "insertions": 3926,
            "deletions": 120,
            "version": "V2",
            "zip_uuid": null,
            "language": {
                "id": 328,
                "name": "NODEJS",
                "description": "Questions with NodeJS techonology attribute",
                "displayName": "Nodejs",
                "tagType": {
                    "id": 53,
                    "name": "TECHNOLOGY_ATTR",
                    "displayName": "Technologies",
                    "featureType": "ATTRIBUTE"
                },
                "imageUrl": "https://s3.amazonaws.com/codejudge-core/tag/default_bg.jpeg",
                "attributes": "{\"mossLanguage\": \"\", \"fileExtension\": \"\"}"
            }
        },
        "code_quality": {
            "bugs": {
                "total": 0,
                "p": 1,
                "ps": 500,
                "paging": {
                    "pageIndex": 1,
                    "pageSize": 500,
                    "total": 0
                },
                "effortTotal": 0,
                "debtTotal": 0,
                "issues": [],
                "components": [],
                "facets": []
            },
            "codesmells": {
                "total": 0,
                "p": 1,
                "ps": 500,
                "paging": {
                    "pageIndex": 1,
                    "pageSize": 500,
                    "total": 0
                },
                "effortTotal": 0,
                "debtTotal": 0,
                "issues": [],
                "components": [],
                "facets": []
            }
        },
        "metrics": {
            "component": {
                "id": "AYCw75cZ-lmI1iRyonyI",
                "key": "run-5352",
                "name": "run-5352",
                "qualifier": "TRK",
                "measures": {
                    "ncloc": "103",
                    "reliability_remediation_effort": "0",
                    "effort_to_reach_maintainability_rating_a": "0",
                    "duplicated_lines_density": "0.0",
                    "sqale_index": "0",
                    "comment_lines_density": "6.4",
                    "blocker_violations": "0",
                    "complexity": "15",
                    "minor_violations": "0",
                    "reopened_issues": "0",
                    "false_positive_issues": "0",
                    "lines": "159",
                    "duplicated_lines": "0",
                    "sqale_rating": "1.0",
                    "sqale_debt_ratio": "0.0",
                    "bugs": "0",
                    "vulnerabilities": "0",
                    "open_issues": "0",
                    "statements": "76",
                    "code_smells": "0",
                    "classes": "0",
                    "violations": "0",
                    "critical_violations": "0",
                    "reliability_rating": "1.0",
                    "duplicated_blocks": "0",
                    "duplicated_files": "0",
                    "line_coverage": "0.0",
                    "file_complexity": "3.0",
                    "uncovered_lines": "76",
                    "functions": "7",
                    "lines_to_cover": "76",
                    "confirmed_issues": "0",
                    "security_remediation_effort": "0",
                    "wont_fix_issues": "0",
                    "info_violations": "0",
                    "major_violations": "0",
                    "security_rating": "1.0",
                    "files": "5",
                    "comment_lines": "7",
                    "cognitive_complexity": "9",
                    "alert_status": "OK",
                    "coverage": "0.0"
                }
            },
            "code_metrics": [
                {
                    "key": "TOTAL_CODESMELLS",
                    "name": "Total Codesmells",
                    "short_desc": "Indicate weaknesses in design.",
                    "desc": "",
                    "is_enabled": true,
                    "value": 0
                },
                {
                    "key": "KEY_CODESMELLS",
                    "name": "Critical and Blocker Codesmells",
                    "short_desc": "Might have missing edge cases and cause runtime issues.",
                    "desc": "",
                    "is_enabled": true,
                    "value": 0
                },
                {
                    "key": "MAINTAINABILITY_RATING",
                    "name": "Maintainability Rating(1-5)",
                    "short_desc": "Effort to fix code smells. Lower the rating, lesser the effort, better the code quality.",
                    "desc": "",
                    "is_enabled": true,
                    "value": 1.0
                },
                {
                    "key": "DUPLICATE_LINE_DENSITY",
                    "name": "Duplicate Lines Density(%)",
                    "short_desc": "Percentage of duplicate lines with respect to all the lines. Higher the value, lower the code quality",
                    "desc": "",
                    "is_enabled": true,
                    "value": 0.0
                },
                {
                    "key": "TOTAL_BUGS",
                    "name": "Total Bugs",
                    "short_desc": "Indicates code breaking errors that must be fixed immediately.",
                    "desc": "",
                    "is_enabled": true,
                    "value": 0
                },
                {
                    "key": "RELIABILITY_RATING",
                    "name": "Reliability Rating(1-5)",
                    "short_desc": "Based on the worst bug severity. Lower the rating, lesser the bugs, higher the code quality",
                    "desc": "",
                    "is_enabled": true,
                    "value": 1.0
                },
                {
                    "key": "COGNITIVE_COMPLEXITY",
                    "name": "Cognitive complexity",
                    "short_desc": "Indicates code readability. Lesser complexity, better readability, better code quality.",
                    "desc": "",
                    "is_enabled": true,
                    "value": 9
                },
                {
                    "key": "CODE_METADATA",
                    "name": "Lines of Code & Classes & Functions",
                    "short_desc": "Indicates Number of lines of code, classes and functions.",
                    "desc": "",
                    "is_enabled": true,
                    "value": "103 & 0 & 7"
                }
            ]
        }
    };
    var sample_data2 = {
        "response": {
            "live_run": {
                "id": 2242,
                "updated_at": "2023-09-03T13:19:50.174166Z",
                "created_at": "2023-09-03T13:19:50.174228Z",
                "score": 0,
                "total_score": 60,
                "app_logs": "",
                "logs_file": null,
                "app_logs_file": null,
                "user_id": 1200,
                "ques_id": 3783,
                "option_id": null,
                "test_uuid": "24c18546-70aa-4c52-bcb4-5516cf1d1d2b",
                "test_type": "TEST",
                "code": null,
                "language_id": 395,
                "config": null,
                "status": 3,
                "show_browser": false,
                "type": "Web_V2",
                "output": "[\n    {\n        \"testCaseName\": \"Display final score\",\n        \"output\": \"[]\",\n        \"status\": \"False\",\n        \"points\": 20,\n        \"score\": 0,\n        \"testCaseId\": 64159,\n        \"message\": \"  ● Test suite failed to run\\n\\n    Cannot find module './src/App' from 'src/__tests__/2.test.js'\\n\\n      1 | import React from 'react';\\n      2 | import { render, screen, fireEvent } from '@testing-library/react';\\n    > 3 | import QuizGame from './src/App';\\n        | ^\\n      4 |\\n      5 | test('display correct score 2', () => {\\n      6 |     render(<QuizGame />);\\n\\n      at Resolver.resolveModule (node_modules/jest-runtime/node_modules/jest-resolve/build/index.js:306:11)\\n      at Object.<anonymous> (src/__tests__/2.test.js:3:1)\\n\",\n        \"testCaseExecutionTime\": 0\n    },\n    {\n        \"testCaseName\": \"The restart button is not working\",\n        \"output\": \"[{\\\"testCaseName\\\": \\\"display correct score 2\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}, {\\\"testCaseName\\\": \\\"restart quiz\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}, {\\\"testCaseName\\\": \\\"restart quiz\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}]\",\n        \"status\": \"True\",\n        \"points\": 20,\n        \"score\": 20,\n        \"testCaseId\": 64160,\n        \"message\": null,\n        \"testCaseExecutionTime\": 2219\n    },\n    {\n        \"testCaseName\": \"Increment Score\",\n        \"output\": \"[{\\\"testCaseName\\\": \\\"display correct score 2\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}, {\\\"testCaseName\\\": \\\"restart quiz\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}, {\\\"testCaseName\\\": \\\"restart quiz\\\", \\\"testCaseResultStatus\\\": \\\"SUCCEEDED\\\", \\\"testCaseExceptionMessage\\\": \\\"\\\", \\\"testCaseExecutionTime\\\": null}, {\\\"testCaseName\\\": \\\"Sample Test\\\", \\\"testCaseResultStatus\\\": \\\"FAILED\\\", \\\"testCaseExceptionMessage\\\": [\\\"Error: expect(received).toBe(expected) // Object.is equality\\\\n\\\\nExpected: 3\\\\nReceived: 2\\\\n    at Object.<anonymous> (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/src/__tests__/1.test.js:59:19)\\\\n    at Promise.then.completed (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/utils.js:276:28)\\\\n    at new Promise (<anonymous>)\\\\n    at callAsyncCircusFn (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/utils.js:216:10)\\\\n    at _callCircusTest (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/run.js:212:40)\\\\n    at processTicksAndRejections (node:internal/process/task_queues:95:5)\\\\n    at _runTest (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/run.js:149:3)\\\\n    at _runTestsForDescribeBlock (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/run.js:63:9)\\\\n    at run (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/run.js:25:3)\\\\n    at runAndTransformResultsToJestFormat (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/legacy-code-todo-rewrite/jestAdapterInit.js:176:21)\\\\n    at jestAdapter (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-circus/build/legacy-code-todo-rewrite/jestAdapter.js:109:19)\\\\n    at runTestInternal (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-runner/build/runTest.js:380:16)\\\\n    at runTest (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-runner/build/runTest.js:472:34)\\\\n    at Object.worker (/private/tmp/24c1854670aa4c52bcb45516cf1d1d2b/08efb63eeaee49279b6e504abda3d793/node_modules/jest-runner/build/testWorker.js:133:12)\\\"], \\\"testCaseExecutionTime\\\": null}]\",\n        \"status\": \"False\",\n        \"points\": 20,\n        \"score\": 0,\n        \"testCaseId\": 64158,\n        \"message\": \"  ● Sample Test\\n\\n    expect(received).toBe(expected) // Object.is equality\\n\\n    Expected: 3\\n    Received: 2\\n\\n      57 |\\n      58 | test('Sample Test', () => {\\n    > 59 |     expect(1 + 1).toBe(3);\\n         |                   ^\\n      60 | });\\n      61 |\\n      62 |\\n\\n      at Object.<anonymous> (src/__tests__/1.test.js:59:19)\\n\",\n        \"testCaseExecutionTime\": 2246\n    }\n]",
                "response": null,
                "expected_response": null,
                "live_run_user_id": null,
                "version": "V3"
            }
        }
    };

    var a = 'Please wait for a few minutes until your code is being compiled.';
    var TESTCASE_STATUS = {
        PASSED: { label: 'Passed', class: 'test-success' },
        SUCCEEDED: { label: 'Passed', class: 'test-success' },
        FAILED: { label: 'Failed', class: 'test-danger' },
        True: { label: 'Passed', class: 'test-success' },
        true: { label: 'Passed', class: 'test-success' },
        False: { label: 'Failed', class: 'test-danger' },
        false: { label: 'Failed', class: 'test-danger' },
    };
    var CodeSubmissionComponent = /** @class */ (function () {
        function CodeSubmissionComponent(cd, apiService, dialogRef, data) {
            this.cd = cd;
            this.apiService = apiService;
            this.dialogRef = dialogRef;
            this.data = data;
            this.testCaseCols = ['testCaseName', 'points', 'score', 'testCaseExecutionTime', 'status', 'actions'];
            this.subTestCaseCols = ['testCaseName', 'testCaseResultStatus', 'testCaseExceptionMessage'];
            this.submission_status_list = {
                UPLOADING: { name: 'UPLOADING', progress: 20, label: 'Uploading your code to the server...', compLabel: 'Code has been successfully uploaded to the server', complete: false },
                SAVING: { name: 'SAVING', progress: 50, label: 'Setting up your code in a workspace (this usually takes around 1-2 minutes)...', compLabel: 'Code has been successfully set up in a workspace', complete: false },
                RUNNING: { name: 'RUNNING', progress: 100, label: 'Test cases executed successfully', compLabel: 'Test cases executed successfully', complete: false },
            };
            this.progress = 0;
            this.loaded = false;
            this.TESTCASE_STATUS = TESTCASE_STATUS;
            this.originalOrder = function (a, b) {
                return 0;
            };
        }
        CodeSubmissionComponent.prototype.ngOnInit = function () {
            var _this = this;
            var regex = /\.(test|spec)\.(js|ts)$/;
            var files = lodash.pickBy(this.data.files, (function (value, key) { return !regex.test(key); }));
            this.subs = AWS.uploadFile({ file: JSON.stringify(files), path: this.data.test_uuid + "/questions/" + this.data.question.id, name: 'solution.json' })
                .pipe(operators.tap(function () { return _this.updateStatus(_this.submission_status_list.UPLOADING); }), operators.mergeMap(function (response) { return _this.data.type === 'RUN' ? _this.saveLiveRun(response.url) : _this.saveSubmission(response.url); }), operators.tap(function () { return _this.updateStatus(_this.submission_status_list.RUNNING); }), operators.delay(3000))
                .subscribe(function (results) {
                var _a;
                if (results.status <= 2) {
                    _this.results = Object.assign(Object.assign({}, results), { logs: (_a = results.logs) !== null && _a !== void 0 ? _a : 'Request timed-out. Kindly re-submit the solution.' });
                }
                else {
                    _this.results = results;
                }
                _this.loaded = true;
            });
        };
        CodeSubmissionComponent.prototype.updateStatus = function (status) {
            status.complete = true;
            this.progress = status.progress;
        };
        CodeSubmissionComponent.prototype.updateError = function (error, status) {
            status.error = error.error.message;
            return rxjs.throwError(error);
        };
        CodeSubmissionComponent.prototype.closeDialog = function () {
            this.dialogRef.close(this.results);
        };
        CodeSubmissionComponent.prototype.saveLiveRun = function (workspace_url) {
            var _this = this;
            return this.apiService.saveLiveRun(this.data.question, this.data.test_uuid, this.data.test_type, this.data.language_id, workspace_url, this.data.portal)
                .pipe(operators.catchError(function (err) { return _this.updateError(err, _this.submission_status_list.SAVING); }), 
            // tap(() => this.updateStatus(this.submission_status_list.SAVING)),
            operators.mergeMap(function (response) { return _this.apiService.getLiveRunStatus(response.id, _this.data.portal, function (results) { return _this.updateRunProgress(results); }).pipe(operators.tap(function () { return _this.updateStatus(_this.submission_status_list.SAVING); }), operators.catchError(function (err) { return _this.updateError(err, _this.submission_status_list.SAVING); })); }));
        };
        CodeSubmissionComponent.prototype.saveSubmission = function (workspace_url) {
            var _this = this;
            return this.apiService.saveSubmission(this.data.question, this.data.test_uuid, this.data.test_type, this.data.language_id, workspace_url, this.data.portal)
                .pipe(operators.catchError(function (err) { return _this.updateError(err, _this.submission_status_list.SAVING); }), 
            // tap(() => this.updateStatus(this.submission_status_list.SAVING)),
            operators.mergeMap(function (response) { return _this.apiService.getSubmisssionStatus(response.id, function (results) { return _this.updateRunProgress(results); }).pipe(operators.tap(function () { return _this.updateStatus(_this.submission_status_list.SAVING); }), operators.catchError(function (err) { return _this.updateError(err, _this.submission_status_list.SAVING); })); }));
        };
        CodeSubmissionComponent.prototype.updateRunProgress = function (results) {
            this.progress = this.progress < 90 ? this.progress + 4 : this.progress;
            this.cd.markForCheck();
        };
        CodeSubmissionComponent.prototype.expandElement = function (element) {
            this.testCaseElement = this.testCaseElement === element ? null : element;
        };
        CodeSubmissionComponent.prototype.expandSubTestCaseElement = function (element) {
            this.subTestCaseElement = this.subTestCaseElement === element ? null : element;
        };
        CodeSubmissionComponent.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this.subs) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        return CodeSubmissionComponent;
    }());
    CodeSubmissionComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodeSubmissionComponent, deps: [{ token: i0__namespace.ChangeDetectorRef }, { token: ApiService }, { token: i2__namespace.MatDialogRef }, { token: i2.MAT_DIALOG_DATA }], target: i0__namespace.ɵɵFactoryTarget.Component });
    CodeSubmissionComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: CodeSubmissionComponent, selector: "lib-code-submission", ngImport: i0__namespace, template: "<div class=\"popup\">\n    <div class=\"popup__header\">\n        <h5 class=\"title\">Code Submission</h5>\n        <button mat-icon-button color=\"warn\" (click)=\"closeDialog()\">\n            <mat-icon style=\"font-size: 1.7rem !important;\">close</mat-icon>\n        </button>\n    </div>\n    <div class=\"popup__body\">\n        <div *ngIf=\"!loaded\" class=\"progress--stepers\">\n            <div class=\"status-progress\">\n                <mat-progress-bar mode=\"determinate\" [value]=\"progress\"></mat-progress-bar>\n            </div>\n            <div *ngFor=\"let item of submission_status_list|keyvalue:originalOrder\" class=\"status-steppers\">\n                <div class=\"status-steppers__icon\">\n                    <mat-icon *ngIf=\"!item.value['error']\"\n                        [ngClass]=\"{'complete': item.value['complete']}\">check_circle</mat-icon>\n                    <mat-icon *ngIf=\"item.value['error']\" class=\"error\"\n                        [matTooltip]=\"item.value['error']\">cancel</mat-icon>\n                </div>\n                <div class=\"status-steppers__label\">\n                    {{item.value['complete'] ? item.value['compLabel'] : item.value['label']}}\n                </div>\n            </div>\n        </div>\n        <div *ngIf=\"loaded\" class=\"scroll-container\">\n            <div *ngIf=\"results?.output?.length\" class=\"tescases-table\">\n                <mat-table class=\"test-case-details\" [dataSource]=\"results?.output\" multiTemplateDataRows>\n                    <ng-container matColumnDef=\"testCaseName\">\n                        <mat-header-cell *matHeaderCellDef> Exercise Name </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div>{{ element.testCaseName }}</div>\n                        </mat-cell>\n                    </ng-container>\n\n                    <ng-container matColumnDef=\"points\">\n                        <mat-header-cell *matHeaderCellDef> Points </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div>{{ element.points }}</div>\n                        </mat-cell>\n                    </ng-container>\n\n                    <ng-container matColumnDef=\"score\">\n                        <mat-header-cell *matHeaderCellDef> Score </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div>{{ element.score }}</div>\n                        </mat-cell>\n                    </ng-container>\n\n                    <ng-container matColumnDef=\"testCaseExecutionTime\">\n                        <mat-header-cell *matHeaderCellDef> Time(ms) </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div>{{ element.testCaseExecutionTime }}</div>\n                        </mat-cell>\n                    </ng-container>\n\n                    <ng-container matColumnDef=\"status\">\n                        <mat-header-cell *matHeaderCellDef> Status </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div [ngClass]=\"TESTCASE_STATUS[element.status].class\">\n                                {{ TESTCASE_STATUS[element.status].label }}\n                            </div>\n                        </mat-cell>\n                    </ng-container>\n\n                    <ng-container matColumnDef=\"actions\">\n                        <mat-header-cell *matHeaderCellDef> Actions </mat-header-cell>\n                        <mat-cell *matCellDef=\"let element\">\n                            <div class=\"\">\n                                <button *ngIf=\"element.output?.length || element.message\" mat-icon-button\n                                    (click)=\"expandElement(element)\">\n                                    <mat-icon\n                                        [@rotateAnimation]=\"testCaseElement === element ? false : true\">expand_more\n                                    </mat-icon>\n                                </button>\n                                <div *ngIf=\"!element.output?.length && !element.message\">-</div>\n                            </div>\n                        </mat-cell>\n                    </ng-container>\n\n\n                    <ng-container matColumnDef=\"expandedDetail\">\n                        <td mat-cell *matCellDef=\"let element\" [attr.colspan]=\"testCaseCols.length\"\n                            [@fadeInAnimation]=\"element == testCaseElement ? 'expanded' : 'collapsed'\">\n                            <ng-container *ngIf=\"element.output?.length\" [ngTemplateOutlet]=\"subtestcases\"\n                                [ngTemplateOutletContext]=\"{testcase: element}\"></ng-container>\n\n                            <div *ngIf=\"!element.output?.length && element.message\"\n                                class=\"exception-details exercise-logs\">\n                                <pre [innerHTML]=\"element.message\"></pre>\n                            </div>\n                        </td>\n                    </ng-container>\n\n\n                    <mat-header-row *matHeaderRowDef=\"testCaseCols\"></mat-header-row>\n                    <mat-row class=\"cursor-pointer\" *matRowDef=\"let element; columns: testCaseCols;\">\n                    </mat-row>\n\n                    <mat-row [class.expanded-row]=\"testCaseElement === row\"\n                        *matRowDef=\"let row; columns: ['expandedDetail']\" class=\"expand-detail-row\"></mat-row>\n                </mat-table>\n            </div>\n            <div *ngIf=\"!results?.output?.length && results?.logs\" class=\"logs-container\">\n                <pre [innerHTML]=\"results?.logs\"></pre>\n            </div>\n        </div>\n\n    </div>\n\n    <div class=\"popup__footer\">\n\n    </div>\n</div>\n\n\n<ng-template #subtestcases let-testcase=\"testcase\">\n    <mat-table class=\"subtestcases-table\" [dataSource]=\"testcase.output\" multiTemplateDataRows>\n        <ng-container matColumnDef=\"testCaseName\">\n            <mat-header-cell *matHeaderCellDef> Testcase Name </mat-header-cell>\n            <mat-cell *matCellDef=\"let element\">\n                <div>{{ element.testCaseName }}</div>\n            </mat-cell>\n        </ng-container>\n\n        <ng-container matColumnDef=\"testCaseResultStatus\">\n            <mat-header-cell *matHeaderCellDef> Status </mat-header-cell>\n            <mat-cell *matCellDef=\"let element\">\n                <div [ngClass]=\"TESTCASE_STATUS[element.testCaseResultStatus].class\">\n                    {{ TESTCASE_STATUS[element.testCaseResultStatus].label }}\n                </div>\n            </mat-cell>\n        </ng-container>\n\n        <ng-container matColumnDef=\"testCaseExceptionMessage\">\n            <mat-header-cell *matHeaderCellDef> Exception Message </mat-header-cell>\n            <mat-cell *matCellDef=\"let element\">\n                <div>\n                    <button *ngIf=\"element.testCaseExceptionMessage\" mat-icon-button\n                        (click)=\"expandSubTestCaseElement(element)\">\n                        <mat-icon [@rotateAnimation]=\"subTestCaseElement === element ? false : true\">\n                            expand_more\n                        </mat-icon>\n                    </button>\n                    <div *ngIf=\"!element.testCaseExceptionMessage\">-</div>\n\n                </div>\n            </mat-cell>\n        </ng-container>\n\n        <ng-container matColumnDef=\"expandedDetail\">\n            <td mat-cell *matCellDef=\"let element\" [attr.colspan]=\"subTestCaseCols.length\"\n                [@fadeInAnimation]=\"element == subTestCaseElement ? 'expanded' : 'collapsed'\">\n                <div class=\"exception-details\">\n                    <pre [innerHTML]=\"element.testCaseExceptionMessage\"></pre>\n                </div>\n            </td>\n        </ng-container>\n\n\n        <mat-header-row *matHeaderRowDef=\"subTestCaseCols\"></mat-header-row>\n        <mat-row class=\"cursor-pointer\" *matRowDef=\"let element; columns: subTestCaseCols;\">\n        </mat-row>\n\n        <mat-row [class.expanded-row]=\"subTestCaseElement === row\" *matRowDef=\"let row; columns: ['expandedDetail']\"\n            class=\"expand-detail-row\"></mat-row>\n    </mat-table>\n</ng-template>", styles: [":host .popup{display:flex;flex-direction:column}:host .popup__header{display:flex;align-items:center;justify-content:space-between;height:50px;padding:0 1.5rem;border-bottom:1px solid #ebedf2}:host .popup__header .title{margin:0;padding:0;font-size:1.2em;font-weight:500;color:#48465b}:host .popup__body .progress--stepers{padding:1.5rem}:host .popup__body .scroll-container{overflow:auto;height:calc(80vh - 55px)}:host .popup__body .logs-container{background-color:#000;padding:1rem;color:#fff;word-break:break-word;height:calc(100% - 50px + 2.55rem)}:host .popup__body .logs-container pre{line-height:1.5rem;white-space:break-spaces;color:#fff}:host .popup__body .tescases-table{display:block;overflow-x:auto;height:100%;width:940px}:host .popup__body .tescases-table table{margin-bottom:0}:host .popup__body .tescases-table .mat-row:last-child{border:none}:host .popup__body .tescases-table .test-case-details{table-layout:fixed}:host .popup__body .tescases-table .test-case-details .mat-header-row,:host .popup__body .tescases-table .test-case-details .mat-row{display:flex}:host .popup__body .tescases-table .test-case-details .mat-row,:host .popup__body .tescases-table .test-case-details .mat-header-row{height:unset!important;min-height:3.5em}:host .popup__body .tescases-table .test-case-details .mat-cell{display:inline-flex;align-items:center;font-size:1em;padding:.3rem 20px;font-weight:500}:host .popup__body .tescases-table .test-case-details .mat-header-cell{display:inline-flex;padding:.3rem 20px;font-size:1rem}:host .popup__body .tescases-table .test-case-details .mat-header-cell,:host .popup__body .tescases-table .test-case-details .mat-cell{justify-content:center}:host .popup__body .tescases-table .test-case-details .mat-column-testCaseName{justify-content:flex-start!important;font-weight:400;flex:1 0 20%;max-width:350px}:host .popup__body .tescases-table .test-case-details .mat-column-testCaseName.mat-cell{font-size:1.1rem}:host .popup__body .tescases-table .test-case-details .mat-column-expandedDetail{border:none;padding:0!important;width:100%}:host .popup__body .tescases-table .test-case-details .expand-detail-row{height:unset!important;min-height:unset}:host .popup__body .tescases-table .test-case-details .expand-detail-row:not(.expanded-row){border-bottom-width:0}:host .popup__body .tescases-table .test-case-details .expand-detail-row:not(.expanded-row) .exception-details{display:none}:host .popup__body .tescases-table .test-case-details .exception-details{background-color:#000;padding:1rem;color:#fff;word-break:break-word;max-height:250px;min-height:100px;width:100%;overflow:auto}:host .popup__body .tescases-table .test-case-details .exception-details pre{line-height:1.5rem;white-space:break-spaces;color:#fff;margin:0!important;font-size:1rem!important}:host .popup__body .tescases-table .test-case-details .subtestcases-table{border:1px solid rgba(0,0,0,.12);border-radius:.25rem;margin:1.25rem 3rem;width:100%}:host .popup__body .tescases-table .test-case-details .subtestcases-table .mat-row,:host .popup__body .tescases-table .test-case-details .subtestcases-table .mat-header-row{border:none}:host .popup .status-progress{margin-bottom:25px}:host .popup .mat-progress-bar{height:8px!important;border-radius:4px}:host .popup .mat-progress-bar .mat-progress-bar-fill:after{background-color:#3f51b5}:host .popup .status-steppers{display:flex;align-items:center;justify-content:flex-start;grid-gap:5px;gap:5px;margin-top:15px;padding:0 15px}:host .popup .status-steppers__icon .mat-icon{font-size:22px!important;color:#0000008a}:host .popup .status-steppers__icon .mat-icon.complete{color:#4caf50}:host .popup .status-steppers__icon .mat-icon.error{color:#f44336}:host .popup .status-steppers__label{color:#333;font-size:1.2rem;position:relative;bottom:2px;margin-left:8px}:host .test-success{color:#1ba94c;font-weight:500}:host .test-danger{color:#f44336;font-weight:500}:host .mat-column-testCaseExceptionMessage,:host .mat-column-actions{flex:0 0 20%}:host .mat-column-testCaseExceptionMessage>div:first-child{display:flex;align-items:center;justify-content:center;width:100%}:host .mat-column-testCaseExceptionMessage>div:first-child .exception-title{width:100%;overflow:hidden;text-overflow:ellipsis;white-space:nowrap;font-weight:400}\n"], components: [{ type: i3__namespace.MatButton, selector: "button[mat-button], button[mat-raised-button], button[mat-icon-button],             button[mat-fab], button[mat-mini-fab], button[mat-stroked-button],             button[mat-flat-button]", inputs: ["disabled", "disableRipple", "color"], exportAs: ["matButton"] }, { type: i4__namespace.MatIcon, selector: "mat-icon", inputs: ["color", "inline", "svgIcon", "fontSet", "fontIcon"], exportAs: ["matIcon"] }, { type: i5__namespace.MatProgressBar, selector: "mat-progress-bar", inputs: ["color", "mode", "value", "bufferValue"], outputs: ["animationEnd"], exportAs: ["matProgressBar"] }, { type: i6__namespace.MatTable, selector: "mat-table, table[mat-table]", exportAs: ["matTable"] }, { type: i6__namespace.MatHeaderRow, selector: "mat-header-row, tr[mat-header-row]", exportAs: ["matHeaderRow"] }, { type: i6__namespace.MatRow, selector: "mat-row, tr[mat-row]", exportAs: ["matRow"] }], directives: [{ type: i7__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: i7__namespace.NgForOf, selector: "[ngFor][ngForOf]", inputs: ["ngForOf", "ngForTrackBy", "ngForTemplate"] }, { type: i7__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i8__namespace.MatTooltip, selector: "[matTooltip]", exportAs: ["matTooltip"] }, { type: i6__namespace.MatColumnDef, selector: "[matColumnDef]", inputs: ["sticky", "matColumnDef"] }, { type: i6__namespace.MatHeaderCellDef, selector: "[matHeaderCellDef]" }, { type: i6__namespace.MatHeaderCell, selector: "mat-header-cell, th[mat-header-cell]" }, { type: i6__namespace.MatCellDef, selector: "[matCellDef]" }, { type: i6__namespace.MatCell, selector: "mat-cell, td[mat-cell]" }, { type: i7__namespace.NgTemplateOutlet, selector: "[ngTemplateOutlet]", inputs: ["ngTemplateOutletContext", "ngTemplateOutlet"] }, { type: i6__namespace.MatHeaderRowDef, selector: "[matHeaderRowDef]", inputs: ["matHeaderRowDef", "matHeaderRowDefSticky"] }, { type: i6__namespace.MatRowDef, selector: "[matRowDef]", inputs: ["matRowDefColumns", "matRowDefWhen"] }], pipes: { "keyvalue": i7__namespace.KeyValuePipe }, animations: [fadeInAnimation, rotateAnimation] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodeSubmissionComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'lib-code-submission',
                        templateUrl: './code-submission.component.html',
                        styleUrls: ['./code-submission.component.scss'],
                        animations: [fadeInAnimation, rotateAnimation]
                    }]
            }], ctorParameters: function () {
            return [{ type: i0__namespace.ChangeDetectorRef }, { type: ApiService }, { type: i2__namespace.MatDialogRef }, { type: undefined, decorators: [{
                            type: i0.Inject,
                            args: [i2.MAT_DIALOG_DATA]
                        }] }];
        } });

    /******************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */
    /* global Reflect, Promise, SuppressedError, Symbol */
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b)
                if (Object.prototype.hasOwnProperty.call(b, p))
                    d[p] = b[p]; };
        return extendStatics(d, b);
    };
    function __extends(d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }
    var __assign = function () {
        __assign = Object.assign || function __assign(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s)
                    if (Object.prototype.hasOwnProperty.call(s, p))
                        t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    function __rest(s, e) {
        var t = {};
        for (var p in s)
            if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
                t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }
    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function")
            r = Reflect.decorate(decorators, target, key, desc);
        else
            for (var i = decorators.length - 1; i >= 0; i--)
                if (d = decorators[i])
                    r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }
    function __param(paramIndex, decorator) {
        return function (target, key) { decorator(target, key, paramIndex); };
    }
    function __esDecorate(ctor, descriptorIn, decorators, contextIn, initializers, extraInitializers) {
        function accept(f) { if (f !== void 0 && typeof f !== "function")
            throw new TypeError("Function expected"); return f; }
        var kind = contextIn.kind, key = kind === "getter" ? "get" : kind === "setter" ? "set" : "value";
        var target = !descriptorIn && ctor ? contextIn["static"] ? ctor : ctor.prototype : null;
        var descriptor = descriptorIn || (target ? Object.getOwnPropertyDescriptor(target, contextIn.name) : {});
        var _, done = false;
        for (var i = decorators.length - 1; i >= 0; i--) {
            var context = {};
            for (var p in contextIn)
                context[p] = p === "access" ? {} : contextIn[p];
            for (var p in contextIn.access)
                context.access[p] = contextIn.access[p];
            context.addInitializer = function (f) { if (done)
                throw new TypeError("Cannot add initializers after decoration has completed"); extraInitializers.push(accept(f || null)); };
            var result = (0, decorators[i])(kind === "accessor" ? { get: descriptor.get, set: descriptor.set } : descriptor[key], context);
            if (kind === "accessor") {
                if (result === void 0)
                    continue;
                if (result === null || typeof result !== "object")
                    throw new TypeError("Object expected");
                if (_ = accept(result.get))
                    descriptor.get = _;
                if (_ = accept(result.set))
                    descriptor.set = _;
                if (_ = accept(result.init))
                    initializers.unshift(_);
            }
            else if (_ = accept(result)) {
                if (kind === "field")
                    initializers.unshift(_);
                else
                    descriptor[key] = _;
            }
        }
        if (target)
            Object.defineProperty(target, contextIn.name, descriptor);
        done = true;
    }
    ;
    function __runInitializers(thisArg, initializers, value) {
        var useValue = arguments.length > 2;
        for (var i = 0; i < initializers.length; i++) {
            value = useValue ? initializers[i].call(thisArg, value) : initializers[i].call(thisArg);
        }
        return useValue ? value : void 0;
    }
    ;
    function __propKey(x) {
        return typeof x === "symbol" ? x : "".concat(x);
    }
    ;
    function __setFunctionName(f, name, prefix) {
        if (typeof name === "symbol")
            name = name.description ? "[".concat(name.description, "]") : "";
        return Object.defineProperty(f, "name", { configurable: true, value: prefix ? "".concat(prefix, " ", name) : name });
    }
    ;
    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function")
            return Reflect.metadata(metadataKey, metadataValue);
    }
    function __awaiter(thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try {
                step(generator.next(value));
            }
            catch (e) {
                reject(e);
            } }
            function rejected(value) { try {
                step(generator["throw"](value));
            }
            catch (e) {
                reject(e);
            } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    }
    function __generator(thisArg, body) {
        var _ = { label: 0, sent: function () { if (t[0] & 1)
                throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function () { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f)
                throw new TypeError("Generator is already executing.");
            while (g && (g = 0, op[0] && (_ = 0)), _)
                try {
                    if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done)
                        return t;
                    if (y = 0, t)
                        op = [op[0] & 2, t.value];
                    switch (op[0]) {
                        case 0:
                        case 1:
                            t = op;
                            break;
                        case 4:
                            _.label++;
                            return { value: op[1], done: false };
                        case 5:
                            _.label++;
                            y = op[1];
                            op = [0];
                            continue;
                        case 7:
                            op = _.ops.pop();
                            _.trys.pop();
                            continue;
                        default:
                            if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) {
                                _ = 0;
                                continue;
                            }
                            if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) {
                                _.label = op[1];
                                break;
                            }
                            if (op[0] === 6 && _.label < t[1]) {
                                _.label = t[1];
                                t = op;
                                break;
                            }
                            if (t && _.label < t[2]) {
                                _.label = t[2];
                                _.ops.push(op);
                                break;
                            }
                            if (t[2])
                                _.ops.pop();
                            _.trys.pop();
                            continue;
                    }
                    op = body.call(thisArg, _);
                }
                catch (e) {
                    op = [6, e];
                    y = 0;
                }
                finally {
                    f = t = 0;
                }
            if (op[0] & 5)
                throw op[1];
            return { value: op[0] ? op[1] : void 0, done: true };
        }
    }
    var __createBinding = Object.create ? (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        var desc = Object.getOwnPropertyDescriptor(m, k);
        if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
            desc = { enumerable: true, get: function () { return m[k]; } };
        }
        Object.defineProperty(o, k2, desc);
    }) : (function (o, m, k, k2) {
        if (k2 === undefined)
            k2 = k;
        o[k2] = m[k];
    });
    function __exportStar(m, o) {
        for (var p in m)
            if (p !== "default" && !Object.prototype.hasOwnProperty.call(o, p))
                __createBinding(o, m, p);
    }
    function __values(o) {
        var s = typeof Symbol === "function" && Symbol.iterator, m = s && o[s], i = 0;
        if (m)
            return m.call(o);
        if (o && typeof o.length === "number")
            return {
                next: function () {
                    if (o && i >= o.length)
                        o = void 0;
                    return { value: o && o[i++], done: !o };
                }
            };
        throw new TypeError(s ? "Object is not iterable." : "Symbol.iterator is not defined.");
    }
    function __read(o, n) {
        var m = typeof Symbol === "function" && o[Symbol.iterator];
        if (!m)
            return o;
        var i = m.call(o), r, ar = [], e;
        try {
            while ((n === void 0 || n-- > 0) && !(r = i.next()).done)
                ar.push(r.value);
        }
        catch (error) {
            e = { error: error };
        }
        finally {
            try {
                if (r && !r.done && (m = i["return"]))
                    m.call(i);
            }
            finally {
                if (e)
                    throw e.error;
            }
        }
        return ar;
    }
    /** @deprecated */
    function __spread() {
        for (var ar = [], i = 0; i < arguments.length; i++)
            ar = ar.concat(__read(arguments[i]));
        return ar;
    }
    /** @deprecated */
    function __spreadArrays() {
        for (var s = 0, i = 0, il = arguments.length; i < il; i++)
            s += arguments[i].length;
        for (var r = Array(s), k = 0, i = 0; i < il; i++)
            for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
                r[k] = a[j];
        return r;
    }
    function __spreadArray(to, from, pack) {
        if (pack || arguments.length === 2)
            for (var i = 0, l = from.length, ar; i < l; i++) {
                if (ar || !(i in from)) {
                    if (!ar)
                        ar = Array.prototype.slice.call(from, 0, i);
                    ar[i] = from[i];
                }
            }
        return to.concat(ar || Array.prototype.slice.call(from));
    }
    function __await(v) {
        return this instanceof __await ? (this.v = v, this) : new __await(v);
    }
    function __asyncGenerator(thisArg, _arguments, generator) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var g = generator.apply(thisArg, _arguments || []), i, q = [];
        return i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i;
        function verb(n) { if (g[n])
            i[n] = function (v) { return new Promise(function (a, b) { q.push([n, v, a, b]) > 1 || resume(n, v); }); }; }
        function resume(n, v) { try {
            step(g[n](v));
        }
        catch (e) {
            settle(q[0][3], e);
        } }
        function step(r) { r.value instanceof __await ? Promise.resolve(r.value.v).then(fulfill, reject) : settle(q[0][2], r); }
        function fulfill(value) { resume("next", value); }
        function reject(value) { resume("throw", value); }
        function settle(f, v) { if (f(v), q.shift(), q.length)
            resume(q[0][0], q[0][1]); }
    }
    function __asyncDelegator(o) {
        var i, p;
        return i = {}, verb("next"), verb("throw", function (e) { throw e; }), verb("return"), i[Symbol.iterator] = function () { return this; }, i;
        function verb(n, f) { i[n] = o[n] ? function (v) { return (p = !p) ? { value: __await(o[n](v)), done: false } : f ? f(v) : v; } : f; }
    }
    function __asyncValues(o) {
        if (!Symbol.asyncIterator)
            throw new TypeError("Symbol.asyncIterator is not defined.");
        var m = o[Symbol.asyncIterator], i;
        return m ? m.call(o) : (o = typeof __values === "function" ? __values(o) : o[Symbol.iterator](), i = {}, verb("next"), verb("throw"), verb("return"), i[Symbol.asyncIterator] = function () { return this; }, i);
        function verb(n) { i[n] = o[n] && function (v) { return new Promise(function (resolve, reject) { v = o[n](v), settle(resolve, reject, v.done, v.value); }); }; }
        function settle(resolve, reject, d, v) { Promise.resolve(v).then(function (v) { resolve({ value: v, done: d }); }, reject); }
    }
    function __makeTemplateObject(cooked, raw) {
        if (Object.defineProperty) {
            Object.defineProperty(cooked, "raw", { value: raw });
        }
        else {
            cooked.raw = raw;
        }
        return cooked;
    }
    ;
    var __setModuleDefault = Object.create ? (function (o, v) {
        Object.defineProperty(o, "default", { enumerable: true, value: v });
    }) : function (o, v) {
        o["default"] = v;
    };
    function __importStar(mod) {
        if (mod && mod.__esModule)
            return mod;
        var result = {};
        if (mod != null)
            for (var k in mod)
                if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k))
                    __createBinding(result, mod, k);
        __setModuleDefault(result, mod);
        return result;
    }
    function __importDefault(mod) {
        return (mod && mod.__esModule) ? mod : { default: mod };
    }
    function __classPrivateFieldGet(receiver, state, kind, f) {
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a getter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot read private member from an object whose class did not declare it");
        return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
    }
    function __classPrivateFieldSet(receiver, state, value, kind, f) {
        if (kind === "m")
            throw new TypeError("Private method is not writable");
        if (kind === "a" && !f)
            throw new TypeError("Private accessor was defined without a setter");
        if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver))
            throw new TypeError("Cannot write private member to an object whose class did not declare it");
        return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
    }
    function __classPrivateFieldIn(state, receiver) {
        if (receiver === null || (typeof receiver !== "object" && typeof receiver !== "function"))
            throw new TypeError("Cannot use 'in' operator on non-object");
        return typeof state === "function" ? receiver === state : state.has(receiver);
    }
    function __addDisposableResource(env, value, async) {
        if (value !== null && value !== void 0) {
            if (typeof value !== "object" && typeof value !== "function")
                throw new TypeError("Object expected.");
            var dispose;
            if (async) {
                if (!Symbol.asyncDispose)
                    throw new TypeError("Symbol.asyncDispose is not defined.");
                dispose = value[Symbol.asyncDispose];
            }
            if (dispose === void 0) {
                if (!Symbol.dispose)
                    throw new TypeError("Symbol.dispose is not defined.");
                dispose = value[Symbol.dispose];
            }
            if (typeof dispose !== "function")
                throw new TypeError("Object not disposable.");
            env.stack.push({ value: value, dispose: dispose, async: async });
        }
        else if (async) {
            env.stack.push({ async: true });
        }
        return value;
    }
    var _SuppressedError = typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
        var e = new Error(message);
        return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
    };
    function __disposeResources(env) {
        function fail(e) {
            env.error = env.hasError ? new _SuppressedError(e, env.error, "An error was suppressed during disposal.") : e;
            env.hasError = true;
        }
        function next() {
            while (env.stack.length) {
                var rec = env.stack.pop();
                try {
                    var result = rec.dispose && rec.dispose.call(rec.value);
                    if (rec.async)
                        return Promise.resolve(result).then(next, function (e) { fail(e); return next(); });
                }
                catch (e) {
                    fail(e);
                }
            }
            if (env.hasError)
                throw env.error;
        }
        return next();
    }
    var tslib_es6 = {
        __extends: __extends,
        __assign: __assign,
        __rest: __rest,
        __decorate: __decorate,
        __param: __param,
        __metadata: __metadata,
        __awaiter: __awaiter,
        __generator: __generator,
        __createBinding: __createBinding,
        __exportStar: __exportStar,
        __values: __values,
        __read: __read,
        __spread: __spread,
        __spreadArrays: __spreadArrays,
        __spreadArray: __spreadArray,
        __await: __await,
        __asyncGenerator: __asyncGenerator,
        __asyncDelegator: __asyncDelegator,
        __asyncValues: __asyncValues,
        __makeTemplateObject: __makeTemplateObject,
        __importStar: __importStar,
        __importDefault: __importDefault,
        __classPrivateFieldGet: __classPrivateFieldGet,
        __classPrivateFieldSet: __classPrivateFieldSet,
        __classPrivateFieldIn: __classPrivateFieldIn,
        __addDisposableResource: __addDisposableResource,
        __disposeResources: __disposeResources,
    };

    function generateMonacoTree(input) {
        var output = [];
        var _loop_1 = function (key) {
            var item = input[key];
            var parts = key.split('/').filter(Boolean);
            var folder = output;
            var _loop_2 = function (i) {
                var existingFolder = folder.find(function (entry) { return entry.name === parts[i] && entry.content; });
                if (existingFolder) {
                    folder = existingFolder.content || [];
                }
                else {
                    var newFolder = { name: parts[i], content: [], path: '/' + parts.slice(0, i + 1).join('/') };
                    folder.push(newFolder);
                    folder = newFolder.content;
                }
            };
            for (var i = 0; i < parts.length - 1; i++) {
                _loop_2(i);
            }
            var a = Object.assign({ name: parts[parts.length - 1], path: key }, item);
            if (a.code === null || a.code === undefined) {
                a['content'] = [];
            }
            folder.push(a);
        };
        for (var key in input) {
            _loop_1(key);
        }
        return sortDirectoriesFirst([{ content: output, path: '/', name: 'root' }]);
    }
    function sortDirectoriesFirst(arr) {
        var e_1, _a;
        var sortedArray = __spreadArray([], __read(arr));
        sortedArray.sort(function (a, b) {
            if (a.content && !b.content) {
                return -1; // Place directory before file
            }
            else if (!a.content && b.content) {
                return 1; // Place file after directory
            }
            else {
                return a.name.localeCompare(b.name); // Sort alphabetically
            }
        });
        try {
            for (var sortedArray_1 = __values(sortedArray), sortedArray_1_1 = sortedArray_1.next(); !sortedArray_1_1.done; sortedArray_1_1 = sortedArray_1.next()) {
                var item = sortedArray_1_1.value;
                if (item.content) {
                    item.content = sortDirectoriesFirst(item.content);
                }
            }
        }
        catch (e_1_1) { e_1 = { error: e_1_1 }; }
        finally {
            try {
                if (sortedArray_1_1 && !sortedArray_1_1.done && (_a = sortedArray_1.return)) _a.call(sortedArray_1);
            }
            finally { if (e_1) throw e_1.error; }
        }
        return sortedArray;
    }
    function getAllFilePaths(node) {
        var e_2, _a;
        if (!node || !node.content) {
            return [];
        }
        var filePaths = [];
        try {
            for (var _b = __values(node.content), _c = _b.next(); !_c.done; _c = _b.next()) {
                var item = _c.value;
                var fullPath = item.path;
                if (item.content && item.content.length > 0) {
                    filePaths.push.apply(filePaths, __spreadArray([], __read(getAllFilePaths(item))));
                }
                else if (item.path) {
                    filePaths.push(fullPath);
                }
            }
        }
        catch (e_2_1) { e_2 = { error: e_2_1 }; }
        finally {
            try {
                if (_c && !_c.done && (_a = _b.return)) _a.call(_b);
            }
            finally { if (e_2) throw e_2.error; }
        }
        return filePaths;
    }
    function getParentNode(nodes, path) {
        function findParentRecursive(currentNodes) {
            var e_3, _a;
            try {
                for (var currentNodes_1 = __values(currentNodes), currentNodes_1_1 = currentNodes_1.next(); !currentNodes_1_1.done; currentNodes_1_1 = currentNodes_1.next()) {
                    var node = currentNodes_1_1.value;
                    if (node.content && node.content.some(function (subNode) { return subNode.path === path; })) {
                        return node;
                    }
                    if (node.content) {
                        var foundParent = findParentRecursive(node.content);
                        if (foundParent) {
                            return foundParent;
                        }
                    }
                }
            }
            catch (e_3_1) { e_3 = { error: e_3_1 }; }
            finally {
                try {
                    if (currentNodes_1_1 && !currentNodes_1_1.done && (_a = currentNodes_1.return)) _a.call(currentNodes_1);
                }
                finally { if (e_3) throw e_3.error; }
            }
            return null;
        }
        return findParentRecursive(nodes);
    }
    var isFileTypeValid = function (filename, fileType) {
        var allowedFileTypes = ['text'];
        var allowedExt = ['ts', 'tsx', 'jsx', 'js'];
        var ext = filename.split('.').slice(-1)[0];
        if (allowedExt.includes(ext) || allowedFileTypes.some(function (x) { return fileType.startsWith(x); }))
            return true;
        return false;
    };
    var readDataFromFile = function (file) {
        return new Promise(function (resolve, reject) {
            var reader = new FileReader();
            reader.onload = function () { return resolve(reader.result); };
            reader.readAsText(file);
        });
    };

    function useEffectAfterMount(cb, dependencies) {
        var mounted = React.useRef(true);
        React.useEffect(function () {
            if (!mounted.current) {
                return cb();
            }
            mounted.current = false;
        }, dependencies);
    }
    ;

    var getInitialData = function (files) { return ({ files: files, visibleFiles: [], activeFile: null }); };
    var useFiles = function (props) {
        var _b = __read(React.useState(getInitialData(props.files)), 2), state = _b[0], setState = _b[1];
        var _c = __read(React.useState(generateMonacoTree(state.files)), 2), tree = _c[0], setTree = _c[1];
        var initDone = React.useRef(false);
        var emitFiles = React.useRef(false);
        useEffectAfterMount(function () {
            var data = getInitialData(props.files);
            props.onSandboxMount(Object.assign(Object.assign({}, data), operations));
            setState(data);
            updateTree(data.files);
        }, [props.sandboxId]);
        React.useEffect(function () {
            props.onSandboxMount(Object.assign(Object.assign({}, state), operations));
        }, []);
        useEffectAfterMount(function () {
            if (emitFiles.current) {
                props.onFileChanges(state.files);
            }
        }, [state.files]);
        var updateTree = function (files) { return setTree(generateMonacoTree(files)); };
        var addFile = function (files, open) {
            emitFiles.current = true;
            setState(function (prev) {
                var activeFile = prev.activeFile;
                var visibleFiles = prev.visibleFiles;
                if (open) {
                    var newKeys = lodash.keys(files);
                    activeFile = newKeys.slice(-1)[0];
                    visibleFiles = visibleFiles.includes(activeFile) ? visibleFiles : __spreadArray(__spreadArray([], __read(visibleFiles)), [activeFile]);
                }
                var newFiles = Object.assign(Object.assign({}, prev.files), files);
                updateTree(newFiles);
                return Object.assign(Object.assign({}, prev), { files: newFiles, activeFile: activeFile, visibleFiles: visibleFiles });
            });
        };
        var operations = {
            openFile: function (path) {
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, rest = __rest(_a, ["visibleFiles"]);
                    var newPaths = visibleFiles.includes(path)
                        ? visibleFiles
                        : __spreadArray(__spreadArray([], __read(visibleFiles)), [path]);
                    return Object.assign(Object.assign({}, rest), { activeFile: path, visibleFiles: newPaths });
                });
            },
            setActiveFile: function (activeFile) {
                if (state.files[activeFile]) {
                    setState(function (prev) { return (Object.assign(Object.assign({}, prev), { activeFile: activeFile })); });
                }
            },
            updateActiveCode: function (code) {
                emitFiles.current = true;
                setState(function (_a) {
                    var _b;
                    var files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["files", "activeFile"]);
                    return Object.assign(Object.assign({}, rest), { activeFile: activeFile, files: Object.assign(Object.assign({}, files), (_b = {}, _b[activeFile] = Object.assign(Object.assign({}, files[activeFile]), { code: code }), _b)) });
                });
            },
            updateFile: function (path, data) {
                emitFiles.current = true;
                setState(function (_a) {
                    var _b;
                    var files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["files", "activeFile"]);
                    var newFiles = Object.assign(Object.assign({}, files), (_b = {}, _b[path] = Object.assign(Object.assign({}, files[path]), data), _b));
                    updateTree(newFiles);
                    return Object.assign(Object.assign({}, rest), { activeFile: activeFile, files: newFiles });
                });
            },
            addFile: addFile,
            closeFile: function (path) {
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, activeFile = _a.activeFile, prev = __rest(_a, ["visibleFiles", "activeFile"]);
                    var indexOfRemovedPath = visibleFiles.indexOf(path);
                    var newPaths = visibleFiles.filter(function (openPath) { return openPath !== path; });
                    return Object.assign(Object.assign({}, prev), { activeFile: path === activeFile
                            ? indexOfRemovedPath === 0
                                ? visibleFiles[1]
                                : visibleFiles[indexOfRemovedPath - 1]
                            : activeFile, visibleFiles: newPaths });
                });
            },
            deleteFile: function (path) {
                emitFiles.current = true;
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["visibleFiles", "files", "activeFile"]);
                    var newFiles = Object.assign({}, files);
                    delete newFiles[path];
                    var remainingVisibleFiles = visibleFiles.filter(function (openPath) { return openPath !== path; });
                    updateTree(newFiles);
                    return Object.assign(Object.assign({}, rest), { visibleFiles: remainingVisibleFiles, activeFile: path === activeFile ? remainingVisibleFiles.slice(-1)[0] : activeFile, files: newFiles });
                });
            },
            renameFile: function (oldPath, newPath) {
                emitFiles.current = true;
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["visibleFiles", "files", "activeFile"]);
                    var newFiles = Object.assign({}, files);
                    var existdata = newFiles[oldPath];
                    delete newFiles[oldPath];
                    newFiles[newPath] = existdata;
                    var newVisibleFiles = visibleFiles.map(function (openPath) { return openPath === oldPath ? newPath : openPath; });
                    updateTree(newFiles);
                    return Object.assign(Object.assign({}, rest), { visibleFiles: newVisibleFiles, activeFile: oldPath === activeFile ? newPath : activeFile, files: newFiles });
                });
            },
            renameFolder: function (nodePath, oldPath, node) {
                emitFiles.current = true;
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["visibleFiles", "files", "activeFile"]);
                    var newFiles = Object.assign({}, files);
                    var childFiles = getAllFilePaths(node);
                    if (childFiles === null || childFiles === void 0 ? void 0 : childFiles.length) {
                        childFiles.forEach(function (oldFilePath) {
                            var newFilePath = nodePath + "/" + oldFilePath.split('/').filter(Boolean).pop();
                            var visibleIndex = visibleFiles.indexOf(oldFilePath);
                            if (visibleIndex !== -1) {
                                visibleFiles[visibleIndex] = newFilePath;
                            }
                            var exitData = newFiles[oldFilePath];
                            delete newFiles[oldFilePath];
                            newFiles[newFilePath] = exitData;
                            activeFile = activeFile === oldFilePath ? newFilePath : activeFile;
                        });
                    }
                    else {
                        delete newFiles[oldPath];
                        newFiles[nodePath] = {};
                    }
                    updateTree(newFiles);
                    return Object.assign(Object.assign({}, rest), { visibleFiles: visibleFiles, activeFile: activeFile, files: newFiles });
                });
            },
            addFolder: function (path) {
                var _b;
                addFile((_b = {}, _b[path] = {}, _b));
            },
            deleteFolder: function (nodePath, node) {
                emitFiles.current = true;
                setState(function (_a) {
                    var visibleFiles = _a.visibleFiles, files = _a.files, activeFile = _a.activeFile, rest = __rest(_a, ["visibleFiles", "files", "activeFile"]);
                    var newFiles = Object.assign({}, files);
                    var childFiles = getAllFilePaths(node);
                    if (childFiles === null || childFiles === void 0 ? void 0 : childFiles.length) {
                        childFiles.forEach(function (oldFilePath) {
                            var visibleIndex = visibleFiles.indexOf(oldFilePath);
                            if (visibleIndex !== -1) {
                                visibleFiles.splice(visibleIndex, 1);
                            }
                            delete newFiles[oldFilePath];
                        });
                    }
                    else {
                        delete newFiles[nodePath];
                    }
                    updateTree(newFiles);
                    return Object.assign(Object.assign({}, rest), { visibleFiles: visibleFiles, activeFile: childFiles.includes(activeFile) ? visibleFiles.slice(-1)[0] : activeFile, files: newFiles, tree: generateMonacoTree(newFiles) });
                });
            },
            uploadFiles: function (filelist, nodePath) { return __awaiter(void 0, void 0, void 0, function () {
                var newFiles, index, file, code;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            nodePath = nodePath === '/' ? '' : nodePath;
                            if (!filelist.length) return [3 /*break*/, 5];
                            newFiles = {};
                            index = 0;
                            _b.label = 1;
                        case 1:
                            if (!(index < filelist.length)) return [3 /*break*/, 4];
                            file = filelist[index];
                            if (!isFileTypeValid(file.name, file.type)) return [3 /*break*/, 3];
                            return [4 /*yield*/, readDataFromFile(file)];
                        case 2:
                            code = _b.sent();
                            newFiles[nodePath + "/" + (file['webkitRelativePath'] || file.name)] = { code: code };
                            _b.label = 3;
                        case 3:
                            index++;
                            return [3 /*break*/, 1];
                        case 4:
                            addFile(newFiles);
                            _b.label = 5;
                        case 5: return [2 /*return*/];
                    }
                });
            }); },
            runCode: function () {
                props.onRunCode(state.files);
            },
            submitCode: function () {
                props.onSubmitCode(state.files);
            }
        };
        return [Object.assign({}, state), operations, tree];
    };

    var SandboxReactContext = React.createContext(undefined);
    var SandboxProvider = function (props) {
        var _a = __read(React.useState(), 2), focusedNode = _a[0], setFocusedNode = _a[1];
        var _b = __read(useFiles(props), 3), fileState = _b[0], fileOperations = _b[1], tree = _b[2];
        var _c = __read(React.useState(props.theme || 'light'), 2), theme = _c[0], setTheme = _c[1];
        React.useEffect(function () {
            setFocusedNode(tree[0]);
        }, []);
        var contextValue = {
            sandbox: Object.assign(Object.assign({}, fileState), fileOperations),
            props: props,
            focusedNode: focusedNode,
            setFocusedNode: setFocusedNode,
            theme: theme,
            setTheme: setTheme,
            tree: tree
        };
        return (React__default["default"].createElement(SandboxReactContext.Provider, { value: contextValue }, props.children));
    };

    function useSandbox() {
        var context = React__namespace.useContext(SandboxReactContext);
        if (!context) {
            throw new Error('useSandbox must be used within a SandboxProvider');
        }
        return context;
    }

    var SandboxTemplates = {
        REACT: {
            name: 'REACT',
            dn: 'React',
            icon: 'https://cdn.jsdelivr.net/npm/material-icon-theme@3.7.1/icons/react.svg',
            description: 'lorem ipsum',
            boilerplateCodeS3Url: 'https://codejudge-proctoring-dev-v2.s3.us-east-1.amazonaws.com/2605124f844448b28022fdff00428946/questions/3776/1693984585109--6efee863-1755-4bc4-939b-3a4c1ad67c5f--solution.json',
            testFilePath: '/src/__tests__/{{testFilename}}.test.js'
        },
        VANILLA: {
            name: 'VANILLA',
            dn: 'Javascript',
            icon: 'https://cdn.jsdelivr.net/npm/material-icon-theme@3.7.1/icons/javascript.svg',
            description: 'lorem ipsum',
            boilerplateCodeS3Url: 'https://codejudge-proctoring-dev-v2.s3.us-east-1.amazonaws.com/2605124f844448b28022fdff00428946/questions/3776/1693983937815--5f1dcd5c-74b2-4431-b878-4eaeb3b77278--solution.json',
            testFilePath: '/__tests__/{{testFilename}}.test.js'
        }
    };
    var other = {
        'vanilla-ts': {},
        'react-ts': {},
    };

    var _a, _b;
    var createTheme = (_a = core.createStitches({
        prefix: 'sp'
    }), _a.createTheme), css = _a.css, getCssText = _a.getCssText, keyframes = _a.keyframes;
    var sandpackMainContainer = css({
        // boxShadow: '0 6px 16px 0 rgba(0,0,0,.2)',
        border: 'none !important'
    });
    var iconStandaloneClassName = css({
        svg: { margin: "auto" },
    });
    var buttonClassName = css((_b = {
            appearance: "none",
            outline: "none",
            display: "flex",
            alignItems: "center",
            fontSize: "inherit",
            fontFamily: "inherit",
            backgroundColor: "transparent",
            transition: "color $default, background $default",
            cursor: "pointer",
            color: "$colors$clickable",
            border: 0,
            textDecoration: "none",
            "&:disabled": { color: "$colors$disabled" },
            "&:hover:not(:disabled,[data-active='true'])": { color: "$colors$hover" },
            '&[data-active="true"]': { color: "$colors$accent" },
            img: {
                minWidth: "$space$4",
                width: "$space$4",
                height: "$space$4",
            }
        },
        _b["&." + iconStandaloneClassName] = {
            padding: "$space$1",
            height: "$space$7",
            display: "flex",
        },
        // If there's a children besides the icon
        _b["&." + iconStandaloneClassName + "&:not(:has(span))"] = {
            width: "$space$7",
        },
        _b["&." + iconStandaloneClassName + "&:has(svg + span)"] = {
            paddingRight: "$space$3",
            paddingLeft: "$space$2",
            gap: "$space$1",
        },
        _b['&.sp-FileManager-action'] = {
            padding: '4px',
            fontSize: '15px'
        },
        _b));
    var placeholderClassName = css({
        margin: "0",
        display: "block",
        fontFamily: "$font$mono",
        fontSize: "$font$size",
        color: "$syntax$color$plain",
        lineHeight: "$font$lineHeight",
    });
    var tabButton$1 = css({
        padding: "0 $space$2",
        height: "$layout$headerHeight",
        whiteSpace: "nowrap",
        "&:focus": { outline: "none" },
    });
    var runButton = css({
        color: "#116de3",
        backgroundColor: "#fff",
        border: "1px solid #116de3"
    });
    var submitButton = css({
        color: "#fff",
        backgroundColor: "#116de3",
    });
    var actionButtons = css({
        display: "inline-block",
        textAlign: "center",
        boxSizing: "border-box",
        whiteSpace: "nowrap",
        verticalAlign: "middle",
        userSelect: "none",
        borderRadius: "4px",
        color: "#fff",
        cursor: "pointer",
        border: "1px solid transparent",
        fontSize: "14px", lineHeight: "16px", padding: "6px 15px",
        fontWeight: 600
    });
    var consoleContainerStyle = css({
        '.console-tabs': {
            height: '40px',
            display: 'flex',
            justifyContent: 'space-between',
            background: "$colors$surface1",
            borderBottom: "1px solid $colors$surface2",
            ".console-tabs__actions": {
                display: 'flex',
                justifyContent: 'space-between',
                alignItems: 'center',
                padding: "0 24px",
                gap: '10px'
            }
        },
        '.console-view': {
            height: 'calc(100% - 40px)',
            overflow: 'auto'
        },
        '.console-tabs__tabs-label': {
            height: "40px",
            padding: "0 24px",
            cursor: "pointer",
            opacity: 0.6,
            display: "inline-flex",
            justifyContent: "flex-start",
            alignItems: "center",
            textDecoration: 'none'
        }
    });

    var tabsClassName = css({
        borderBottom: "1px solid $colors$surface2",
        background: "$colors$surface1",
        minHeight: '$layout$headerHeight',
        display: 'flex',
        alignItems: 'center'
    });
    var tabsScrollableClassName = css({
        overflow: "auto",
        display: "flex",
        flexWrap: "nowrap",
        alignItems: "stretch",
        padding: 0,
        height: '100%',
        flex: 1
    });
    var closeButtonClassName = css({
        padding: "0 $space$1 0 $space$1",
        borderRadius: "$border$radius",
        width: "$space$5",
        svg: {
            width: "$space$3",
            height: "$space$3",
            display: "block",
            position: "relative",
            top: 1,
        },
    });
    var tabButton = css({
        padding: "0 $space$2",
        gap: 5,
        whiteSpace: "nowrap",
        borderRight: '1px solid $colors$surface2',
        position: 'relative',
        '&[data-active="true"]': {
            color: "$colors$clickable",
        },
        "&:focus": { outline: "none" },
        '.tab-active': {
            width: '100%',
            height: 3,
            position: 'absolute',
            right: 0,
            left: 0,
            top: 0,
            background: '$colors$accent'
        }
    });
    var FileTabs = function () {
        var _a = useSandbox(), sandbox = _a.sandbox, props = _a.props;
        var classNames = sandpackReact.useClassNames();
        var _b = __read(React.useState([]), 2), tabs = _b[0], setTabs = _b[1];
        React.useEffect(function () {
            var tabs = sandbox.visibleFiles.map(function (path) { return ({ label: path.split('/').filter(Boolean).pop(), path: path }); });
            setTabs(tabs);
        }, [sandbox.visibleFiles]);
        var handleCloseFile = function (ev, path) {
            ev.stopPropagation();
            sandbox.closeFile(path);
        };
        var getIcon = function (fileName) {
            var IconPath = function (icon) { return React__default["default"].createElement("img", { className: "monaco-tree-icon", src: "https://cdn.jsdelivr.net/npm/material-icon-theme@3.7.1/icons/" + icon }); };
            var fileIcon = vscodeMaterialIconThemeJs.getIconForFile(fileName);
            return IconPath(fileIcon);
        };
        return (React__default["default"].createElement("div", { className: classNames("tabs", [tabsClassName]) }, React__default["default"].createElement("div", { "aria-label": "Select active file", className: classNames("tabs-scrollable-container", [
                tabsScrollableClassName,
            ]), role: "tablist" }, tabs.map(function (_a) {
            var path = _a.path, label = _a.label;
            return (React__default["default"].createElement("button", { key: path, "aria-selected": path === sandbox.activeFile, className: classNames("tab-button", [buttonClassName, tabButton]), "data-active": path === sandbox.activeFile, onClick: function () { return sandbox.setActiveFile(path); }, role: "tab", title: path, type: "button" }, path === sandbox.activeFile && React__default["default"].createElement("div", { className: "tab-active" }), getIcon(label), React__default["default"].createElement("span", null, label), React__default["default"].createElement("span", { className: classNames("close-button", [closeButtonClassName]), onClick: function (event) { return handleCloseFile(event, path); } }, React__default["default"].createElement(sandpackReact.CloseIcon, null))));
        }))));
    };

    var useActiveCode = function () {
        var _a, _b, _c;
        var sandbox = useSandbox().sandbox;
        return {
            code: (_a = sandbox.files[sandbox.activeFile]) === null || _a === void 0 ? void 0 : _a.code,
            readOnly: (_c = (_b = sandbox.files[sandbox.activeFile]) === null || _b === void 0 ? void 0 : _b.readOnly) !== null && _c !== void 0 ? _c : false,
            updateCode: sandbox.updateActiveCode,
        };
    };

    var DEFAULT_EDITOR_OPTIONS = {
        wordWrap: 'on',
        minimap: { enabled: false },
        roundedSelection: true,
        tabCompletion: 'on',
        scrollBeyondLastLine: true,
        overviewRulerBorder: false,
        glyphMargin: false,
        fixedOverflowWidgets: true,
        renderWhitespace: 'all',
        inlayHints: { enabled: 'off' },
        contextmenu: false,
        wrappingIndent: 'indent',
        fontFamily: "'Monaco', 'Menlo', 'Ubuntu Mono', 'Consolas', 'source-code-pro', monospace",
        codeLens: false,
        lineNumbers: 'on',
        lightbulb: { enabled: false },
    };

    var editorClassName = css({
        flex: 1,
        position: "relative",
        overflow: "auto",
        background: "$colors$surface1"
    });
    function MonacoEditor(props) {
        var classNames = sandpackReact.useClassNames();
        return React__default["default"].createElement("div", { className: classNames("code-editor", [editorClassName]) }, React__default["default"].createElement(Editor__default["default"], Object.assign({}, props, { options: Object.assign(Object.assign({}, DEFAULT_EDITOR_OPTIONS), props.options), ref: props.onEditorMount })));
    }

    var noFileStyles = css({
        height: "100%",
        width: "100%",
        display: "flex",
        alignItems: "center",
        justifyContent: "center",
        flexDirection: 'column',
        p: {
            opacity: 0.5,
            margin: '20px 0',
            fontSize: '1.3rem'
        },
        img: {
            height: 30
        }
    });
    function SandboxEditor(props) {
        var _a;
        var classNames = sandpackReact.useClassNames();
        var _b = useActiveCode(), code = _b.code, updateCode = _b.updateCode, readOnly = _b.readOnly;
        var _c = useSandbox(), sandbox = _c.sandbox, theme = _c.theme, config = _c.props;
        var editorRef = React.useRef(null);
        var _d = __read(React.useState(''), 2), value = _d[0], setValue = _d[1];
        React.useEffect(function () {
            Editor.monaco.editor.setTheme(theme === 'dark' ? 'Default Dark+' : 'Default Light+');
        }, [theme]);
        // useEffect(() => {
        //     editorRef.current?.getModel()?.setValue(code);
        // }, [sandbox.activeFile]);
        return React__default["default"].createElement(sandpackReact.SandpackStack, Object.assign({ style: { height: '100%' }, className: classNames("editor", []) }, props), !!((_a = sandbox.files) === null || _a === void 0 ? void 0 : _a[sandbox.activeFile]) ?
            React__default["default"].createElement(React__default["default"].Fragment, null, React__default["default"].createElement(FileTabs, null), React__default["default"].createElement(MonacoEditor, { onEditorMount: (function (editor) { return editorRef.current = editor; }), fileUri: props.id + "/" + sandbox.activeFile, key: sandbox.activeFile, value: code, options: { readOnly: readOnly || config.readOnly }, onChange: function (value) { return updateCode(value); } })) :
            React__default["default"].createElement("div", { className: classNames("no-file-open", [noFileStyles]) }, React__default["default"].createElement("img", { src: "https://dd2jv4x84axh4.cloudfront.net/enterprise-logo-preprod/a667c197-5d9c-4c3d-9050-5d017019f320/codejudge_logo.png" }), React__default["default"].createElement("p", { className: "fe-no-file-open-text" }, React__default["default"].createElement("span", { className: "fe-left-arrow-emoji" }, " \u2B05 "), " Open a file to get started")));
    }

    var styles$2 = css({
        ul: {
            listStyle: 'none',
            padding: 0,
            margin: 0
        },
        li: {
            minHeight: "32px",
            color: "rgb(153, 153, 153)",
            display: 'flex',
            alignItems: 'center',
            justifyContent: 'space-between',
        },
        '.dependency-title': {
            maxWidth: '60%',
            overflow: "hidden",
            textOverflow: "ellipsis",
            whiteSpace: "nowrap",
            color: "$colors$clickable"
        },
        '.dependency-actions': {
            display: 'flex',
            alignItems: 'center',
            gap: '4px',
            '.delete-btn': {
                padding: "4px 8px",
                backgroundColor: "transparent",
                color: "rgb(153, 153, 153)",
                width: "100%",
                border: "none",
                display: "inline-flex",
                justifyContent: "center",
                alignItems: "center",
                cursor: 'pointer',
                '&:hover': {
                    color: 'rgb(230, 230, 230)'
                }
            }
        }
    });
    var reactSelectStyles$1 = {
        control: function (base) { return (Object.assign(Object.assign({}, base), { minHeight: '28px', marginBottom: '8px', cursor: 'text' })); },
        indicatorsContainer: function (provided) { return (Object.assign(Object.assign({}, provided), { display: 'none' })); },
        menuPortal: function (provided) { return (Object.assign(Object.assign({}, provided), { zIndex: 9999 })); },
        option: function (provided, state) { return (Object.assign(Object.assign({}, provided), { color: 'black' })); }
    };
    var promiseOptions = function (inputValue) {
        return fetch("https://registry.npmjs.com/-/v1/search?text=".concat(inputValue, "&size=5")).then((function (e) {
            return __awaiter(this, void 0, void 0, function () {
                var data;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, e.json()];
                        case 1:
                            data = _c.sent();
                            return [2 /*return*/, data.objects.map(function (t) { return ({
                                    label: t.package.name,
                                    value: t.package.name,
                                    version: t.package.version
                                }); })];
                    }
                });
            });
        }));
    };
    function DependencyManager() {
        var classNames = sandpackReact.useClassNames();
        var sandbox = useSandbox().sandbox;
        var _c = __read(React.useState({}), 2), dependencies = _c[0], setDependencies = _c[1];
        var _d = __read(React.useState(null), 2), selectedValue = _d[0], setSelectedValue = _d[1];
        var loadOptions = React.useCallback(lodash.debounce(function (inputText, callback) {
            promiseOptions(inputText).then(function (options) { return callback(options); });
        }, 400), []);
        var addDependency = function (e) {
            var _a, _b;
            var pkgJson = sandbox.files['/package.json'];
            if (pkgJson) {
                try {
                    pkgJson = JSON.parse(pkgJson.code);
                    var dependencies_1 = (_a = pkgJson.dependencies) !== null && _a !== void 0 ? _a : {};
                    dependencies_1[e.value] = e.version;
                    sandbox.updateFile('/package.json', { code: JSON.stringify(pkgJson, null, 2) });
                    setDependencies((_b = pkgJson.dependencies) !== null && _b !== void 0 ? _b : {});
                    setSelectedValue(null);
                }
                catch (error) {
                }
            }
        };
        React.useEffect(function () {
            updateDependencyList();
        }, []);
        var updateDependencyList = function () {
            var _a;
            var pkgJson = sandbox.files['/package.json'];
            if (pkgJson) {
                try {
                    pkgJson = JSON.parse(pkgJson.code);
                    setDependencies((_a = pkgJson.dependencies) !== null && _a !== void 0 ? _a : {});
                }
                catch (error) {
                }
            }
        };
        var removeDependency = function (dependency) {
            var _a, _b;
            var pkgJson = sandbox.files['/package.json'];
            if (pkgJson) {
                try {
                    pkgJson = JSON.parse(pkgJson.code);
                    var dependencies_2 = (_a = pkgJson.dependencies) !== null && _a !== void 0 ? _a : {};
                    delete dependencies_2[dependency];
                    sandbox.updateFile('/package.json', { code: JSON.stringify(pkgJson, null, 2) });
                    setDependencies((_b = pkgJson.dependencies) !== null && _b !== void 0 ? _b : {});
                }
                catch (error) {
                }
            }
        };
        return React__default["default"].createElement("div", { className: classNames("dependency-manager", [styles$2]) }, React__default["default"].createElement(AsyncSelect__default["default"], { value: selectedValue, placeholder: 'Add Dependency', styles: reactSelectStyles$1, noOptionsMessage: function () { return null; }, loadOptions: loadOptions, onChange: function (e) { return addDependency(e); } }), React__default["default"].createElement("ul", null, " ", Object.keys(dependencies).map(function (x) {
            return React__default["default"].createElement("li", { key: x }, React__default["default"].createElement("div", { className: 'dependency-title' }, x), React__default["default"].createElement("div", { className: 'dependency-actions' }, React__default["default"].createElement("div", null, " ", dependencies[x]), React__default["default"].createElement("button", { className: classNames('delete-btn', [buttonClassName]), type: "button", onClick: function () { return removeDependency(x); } }, React__default["default"].createElement("svg", { fill: "currentColor", preserveAspectRatio: "xMidYMid meet", height: "1em", width: "1em", viewBox: "0 0 40 40" }, React__default["default"].createElement("g", null, React__default["default"].createElement("path", { d: "m31.6 10.7l-9.3 9.3 9.3 9.3-2.3 2.3-9.3-9.3-9.3 9.3-2.3-2.3 9.3-9.3-9.3-9.3 2.3-2.3 9.3 9.3 9.3-9.3z" }))))));
        })));
    }

    var FileManagerAction = function (props) {
        var folderUploadInput = React.useRef(null);
        var fileUploadInput = React.useRef(null);
        var classNames = sandpackReact.useClassNames();
        var _a = useSandbox(), uploadFiles = _a.sandbox.uploadFiles, focusedNode = _a.focusedNode, config = _a.props;
        React.useEffect(function () {
            if (folderUploadInput.current !== null) {
                folderUploadInput.current.setAttribute("directory", "");
                folderUploadInput.current.setAttribute("webkitdirectory", "");
                folderUploadInput.current.setAttribute("mozdirectory", "");
            }
        }, [folderUploadInput]);
        var setAddFile = function (event) {
            event.stopPropagation();
            props.setAddFile(true);
        };
        var setAddFolder = function (event) {
            event.stopPropagation();
            props.setAddFolder(true);
        };
        var handleFileChange = function (event) { return __awaiter(void 0, void 0, void 0, function () {
            return __generator(this, function (_a) {
                event.stopPropagation();
                uploadFiles(event.target.files, focusedNode.path);
                return [2 /*return*/];
            });
        }); };
        var openFolderUpload = function (event) {
            event.stopPropagation();
            folderUploadInput.current.click();
        };
        var openFileUpload = function (event) {
            event.stopPropagation();
            fileUploadInput.current.click();
        };
        return React__namespace.createElement(React__namespace.Fragment, null, !config.readOnly &&
            React__namespace.createElement(React__namespace.Fragment, null, React__namespace.createElement(Tooltip__default["default"], { placement: "bottom", content: "Add File", delay: 0 }, React__namespace.createElement("button", { className: classNames('FileManager-action', [buttonClassName]), onClick: setAddFile }, React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 16 16" }, React__namespace.createElement("path", { fillRule: "evenodd", d: "m9.5 1.1 3.4 3.5.1.4v2h-1V6H8V2H3v11h4v1H2.5l-.5-.5v-12l.5-.5h6.7l.3.1zM9 2v3h2.9L9 2zm4 14h-1v-3H9v-1h3V9h1v3h3v1h-3v3z", clipRule: "evenodd" })))), React__namespace.createElement(Tooltip__default["default"], { placement: "bottom", content: "Add Folder", delay: 0 }, React__namespace.createElement("button", { className: classNames('FileManager-action', [buttonClassName]), onClick: setAddFolder }, React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 16 16" }, React__namespace.createElement("path", { fillRule: "evenodd", d: "M14.5 2H7.71l-.85-.85L6.51 1h-5l-.5.5v11l.5.5H7v-1H1.99V6h4.49l.35-.15.86-.86H14v1.5l-.001.51h1.011V2.5L14.5 2zm-.51 2h-6.5l-.35.15-.86.86H2v-3h4.29l.85.85.36.15H14l-.01.99zM13 16h-1v-3H9v-1h3V9h1v3h3v1h-3v3z", clipRule: "evenodd" })))), React__namespace.createElement(Tooltip__default["default"], { placement: "bottom", content: "Upload File", delay: 0 }, React__namespace.createElement("button", { className: classNames('FileManager-action', [buttonClassName]), onClick: openFileUpload }, React__namespace.createElement("input", { style: { display: 'none' }, ref: fileUploadInput, type: "file", onChange: handleFileChange }), React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 32 32" }, React__namespace.createElement("path", { d: "M26.29,6.88,23.12,3.71A5.85,5.85,0,0,0,19,2H9A5,5,0,0,0,4,7V25a5,5,0,0,0,5,5H23a5,5,0,0,0,5-5V11A5.79,5.79,0,0,0,26.29,6.88ZM24.88,8.29a4.24,4.24,0,0,1,.43.52L25.4,9A3.92,3.92,0,0,1,25.85,10H21a1,1,0,0,1-1-1V4.15a3.36,3.36,0,0,1,.45.14h0a4.08,4.08,0,0,1,.58.32l.14.09a3.42,3.42,0,0,1,.52.42ZM23,28H9a3,3,0,0,1-3-3V7A3,3,0,0,1,9,4h9V9a3,3,0,0,0,3,3h5V25A3,3,0,0,1,23,28Z" }), React__namespace.createElement("path", { d: "M22,22a1,1,0,0,0-1,1,1,1,0,0,1-1,1H12a1,1,0,0,1-1-1,1,1,0,0,0-2,0,3,3,0,0,0,3,3h8a3,3,0,0,0,3-3A1,1,0,0,0,22,22Z" }), React__namespace.createElement("path", { d: "M13.71,18.36,15,17.06V21a1,1,0,0,0,2,0V17.06l1.29,1.3a1,1,0,0,0,1.42,0,1,1,0,0,0,0-1.42l-2.4-2.4A1.86,1.86,0,0,0,16.16,14a.44.44,0,0,0-.32,0,1.86,1.86,0,0,0-1.15.51l-2.4,2.4a1,1,0,0,0,1.42,1.42Z" })))), React__namespace.createElement(Tooltip__default["default"], { placement: "bottom", content: "Upload Folder", delay: 0 }, React__namespace.createElement("button", { className: classNames('FileManager-action', [buttonClassName]), onClick: openFolderUpload }, React__namespace.createElement("input", { style: { display: 'none' }, ref: folderUploadInput, type: "file", onChange: handleFileChange, accept: "text/*" }), React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 32 32" }, React__namespace.createElement("path", { d: "M22,20a1,1,0,0,0-1,1,1,1,0,0,1-1,1H12a1,1,0,0,1-1-1,1,1,0,0,0-2,0,3,3,0,0,0,3,3h8a3,3,0,0,0,3-3A1,1,0,0,0,22,20Z", fill: "currentColor" }), React__namespace.createElement("path", { d: "M13.71,16.36,15,15.06V19a1,1,0,0,0,2,0V15.06l1.29,1.3a1,1,0,0,0,1.42,0,1,1,0,0,0,0-1.42l-2.4-2.4A1.83,1.83,0,0,0,16,12h0a1.83,1.83,0,0,0-1.3.54l-2.4,2.4a1,1,0,0,0,1.42,1.42Z", fill: "currentColor" }), React__namespace.createElement("path", { d: "M25,4H7A5,5,0,0,0,2,9V23a5,5,0,0,0,5,5H25a5,5,0,0,0,5-5V9A5,5,0,0,0,25,4Zm3,5V9a4.92,4.92,0,0,0-3-1H16.92A3.05,3.05,0,0,1,14.3,6.44c-.1-.15-.2-.3-.31-.44H25A3,3,0,0,1,28,9Zm0,14a3,3,0,0,1-3,3H7a3,3,0,0,1-3-3V9A3,3,0,0,1,7,6h3a3,3,0,0,1,2.58,1.47A5.06,5.06,0,0,0,16.92,10H25a3,3,0,0,1,3,3Z", fill: "currentColor" }))))));
    };
    var FileActions = function (_a) {
        var setIsEdit = _a.setIsEdit, isFolder = _a.isFolder, path = _a.path, row = _a.row;
        var _b = useSandbox(), _c = _b.sandbox, deleteFile = _c.deleteFile, deleteFolder = _c.deleteFolder, props = _b.props;
        var classNames = sandpackReact.useClassNames();
        var remove = function () {
            if (!isFolder) {
                deleteFile(path);
            }
            else {
                deleteFolder(path, row);
            }
        };
        return (!props.readOnly &&
            React__namespace.createElement(React__namespace.Fragment, null, React__namespace.createElement("span", { className: classNames('FileItem-action', [buttonClassName]), "aria-label": "Rename", onClick: function () { return setIsEdit(true); } }, React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 16 16" }, React__namespace.createElement("path", { d: "M13.23 1h-1.46L3.52 9.25l-.16.22L1 13.59 2.41 15l4.12-2.36.22-.16L15 4.23V2.77L13.23 1zM2.41 13.59l1.51-3 1.45 1.45-2.96 1.55zm3.83-2.06L4.47 9.76l8-8 1.77 1.77-8 8z" }))), React__namespace.createElement("span", { className: classNames('FileItem-action', [buttonClassName]), "aria-label": "Remove", onClick: remove }, React__namespace.createElement("svg", { xmlns: "http://www.w3.org/2000/svg", width: "1em", height: "1em", fill: "currentColor", viewBox: "0 0 16 16" }, React__namespace.createElement("path", { fillRule: "evenodd", d: "M10 3h3v1h-1v9l-1 1H4l-1-1V4H2V3h3V2a1 1 0 0 1 1-1h3a1 1 0 0 1 1 1v1zM9 2H6v1h3V2zM4 13h7V4H4v9zm2-8H5v7h1V5zm1 0h1v7H7V5zm2 0h1v7H9V5z", clipRule: "evenodd" })))));
    };

    var ERROR = {
        ALREADY_EXIST: 'File or folder {{file_name}} already exists at this location',
        EMPTY_FILE: 'File name must be specified',
        EMPTY_FOLDER: 'Folder name must be specified',
    };
    var styles$1 = css({
        flex: 1,
        textAlign: 'left',
        input: {
            maxWidth: "100%",
            display: "block",
            width: "100%",
            padding: "3px 3px 4px 3px",
            backgroundClip: "padding-box",
            border: "1px solid #ced4da",
            borderRadius: "4px",
            lineHeight: '16px !important',
            transition: "border-color .15s ease-in-out,box-shadow .15s ease-in-out",
        },
        'input:focus-visible': {
            outline: '-webkit-focus-ring-color auto 1px'
        },
        position: 'relative',
        '.error': {
            position: 'absolute',
            display: 'block',
            maxWidth: '100%',
            background: '$colors$errorSurface',
            color: '$colors$error',
            borderBottomLeftRadius: "3px",
            borderBottomRightRadius: "3px",
            padding: "5px 5px 10px",
            zIndex: 9,
            border: '1px solid $colors$error'
        }
    });
    var SingleInputForm = function (_a) {
        var currentPath = _a.currentPath, onBlur = _a.onBlur, filename = _a.filename, isFile = _a.isFile, isEdit = _a.isEdit, row = _a.row, props = __rest(_a, ["currentPath", "onBlur", "filename", "isFile", "isEdit", "row"]);
        var _b = __read(React.useState(filename), 2), value = _b[0], setValue = _b[1];
        var _c = useSandbox(), _d = _c.sandbox, renameFile = _d.renameFile, addFile = _d.addFile, renameFolder = _d.renameFolder, addFolder = _d.addFolder, tree = _c.tree;
        var _e = __read(React.useState(), 2), parentRow = _e[0], setParentRow = _e[1];
        var _f = __read(React.useState(), 2), error = _f[0], setError = _f[1];
        var classNames = sandpackReact.useClassNames();
        useEffectAfterMount(function () {
            var valid = isValid();
            setError(valid.errror);
        }, [value]);
        React.useEffect(function () {
            setParentRow(isEdit ? row.path === '/' ? tree[0] : getParentNode(tree, row.path) : row);
        }, [tree]);
        var isValid = function () {
            var copyValue = value === null || value === void 0 ? void 0 : value.trim();
            copyValue = copyValue === null || copyValue === void 0 ? void 0 : copyValue.split('/').filter(Boolean).join('/');
            if (!copyValue) {
                return { valid: false, errror: !isFile ? ERROR.EMPTY_FOLDER : ERROR.EMPTY_FILE };
            }
            if (copyValue !== filename && parentRow) {
                var valid = parentRow.content.every(function (x) { return x.name !== copyValue; });
                return { valid: valid, errror: !valid && Mustache__default["default"].render(ERROR.ALREADY_EXIST, { file_name: copyValue }) };
            }
            else {
                return { valid: true };
            }
        };
        var handleSubmit = function (event) { return event.preventDefault(); };
        var handleBlur = function () {
            var _b;
            var valueOverride = value === null || value === void 0 ? void 0 : value.trim();
            valueOverride = valueOverride === null || valueOverride === void 0 ? void 0 : valueOverride.split('/').filter(Boolean).join('/');
            if (isValid().valid && filename !== valueOverride) {
                var newPath = '/' + (parentRow.path + "/" + valueOverride).split('/').filter(Boolean).join('/');
                if (isFile) {
                    if (isEdit) {
                        renameFile(currentPath, newPath);
                    }
                    else {
                        addFile((_b = {}, _b[newPath] = { code: '' }, _b));
                    }
                }
                else {
                    if (isEdit) {
                        renameFolder(newPath, currentPath, row);
                    }
                    else {
                        addFolder(newPath);
                    }
                }
            }
            onBlur(false);
        };
        var onClick = function (event) {
            event.stopPropagation();
        };
        var handleKeyDown = function (event) {
            if (!isValid().valid) {
                return;
            }
            if (event.key === 'Enter') {
                event.preventDefault();
                handleBlur();
            }
            if (event.key === 'Escape') {
                event.preventDefault();
                handleBlur();
            }
        };
        return (React__default["default"].createElement("form", { onSubmit: handleSubmit, className: classNames('file-input', [styles$1]) }, React__default["default"].createElement("input", { style: {
                maxWidth: '100%',
                border: "1px solid " + (error ? 'red' : 'inherit'),
            }, onBlur: handleBlur, maxLength: 35, autoFocus: true, placeholder: "" + (!isFile ? 'Directory name' : 'File name'), name: "name", type: "text", value: value, onChange: function (e) { return setValue(e.target.value); }, onKeyDown: handleKeyDown, onClick: onClick }), error && React__default["default"].createElement("span", { className: 'error', dangerouslySetInnerHTML: { __html: error } })));
    };

    var _d;
    var monacoTreeStyles = css((_d = {
            position: 'relative',
            '.monaco-tree-row': {
                fontSize: "inherit",
                fontFamily: "inherit",
                backgroundColor: "transparent",
                transition: "color $default, background $default",
                cursor: "pointer",
                color: "$colors$clickable",
                lineHeight: "24px",
                display: "flex",
                gridGap: "6px",
                gap: "6px",
                marginBottom: "6px",
                position: "relative",
                userSelect: 'none',
                alignItems: 'center',
                "&:hover:not([data-active='true'])": { color: "$colors$hover" },
                '&[data-active="true"]': { color: "$colors$accent" },
            },
            '.monaco-tree-icon': {
                width: "16px", height: "22px"
            },
            svg: {
                width: "16px", height: "22px"
            },
            '.monaco-tree-name': {
                textOverflow: "ellipsis",
                whiteSpace: "nowrap",
                overflow: "hidden",
                flex: "1 1 0%",
                textAlign: "left"
            }
        },
        _d["&:hover:not(.editing) .monaco-tree-actions"] = {
            opacity: 1,
            display: "flex",
        },
        _d['.monaco-tree-actions'] = {
            alignItems: "center",
            background: "$colors$surface1",
            bottom: "0",
            display: "none",
            opacity: 0,
            padding: "0 2px",
            position: "absolute",
            right: "0",
            top: "0",
            gap: '4px',
            '.sp-FileItem-action': {
                padding: '4px',
            }
        },
        _d));
    var MonacoFileTree = function (_a) {
        var _b, _c;
        var row = _a.row, _d = _a.depth, depth = _d === void 0 ? 0 : _d, _e = _a.hide, hide = _e === void 0 ? false : _e, clickFile = _a.clickFile, activeFile = _a.activeFile, root = _a.root, props = __rest(_a, ["row", "depth", "hide", "clickFile", "activeFile", "root"]);
        var _f = __read(React__namespace.useState(!!row.content), 1), isFolder = _f[0];
        var _g = __read(React__namespace.useState((!!((_b = row.content) === null || _b === void 0 ? void 0 : _b.length) && false) || root), 2), isOpen = _g[0], setIsOpen = _g[1];
        var _h = __read(React__namespace.useState(false), 2), isEdit = _h[0], setIsEdit = _h[1];
        var _j = __read(React__namespace.useState(false), 2), addNew = _j[0], setAddNew = _j[1];
        var focusedNode = useSandbox().focusedNode;
        var classNames = sandpackReact.useClassNames();
        React__namespace.useEffect(function () {
            if ((props.addFile || props.addFolder) && (focusedNode === null || focusedNode === void 0 ? void 0 : focusedNode.path) === row.path) {
                setAddNew(true);
                setIsOpen(true);
            }
            else if (addNew) {
                setAddNew(false);
            }
        }, [props.addFile, props.addFolder]);
        var getIcon = function () {
            var folder = ['folder-open.svg', 'folder.svg'];
            var IconPath = function (icon) { return React__namespace.createElement("img", { className: "monaco-tree-icon", src: "https://cdn.jsdelivr.net/npm/material-icon-theme@3.7.1/icons/" + icon }); };
            var fileIcon = vscodeMaterialIconThemeJs.getIconForFile(row.name);
            if (!isFolder)
                return IconPath(fileIcon);
            var folderIcon = isOpen ? vscodeMaterialIconThemeJs.getIconForOpenFolder(row.name) : vscodeMaterialIconThemeJs.getIconForFolder(row.name);
            return folder.includes(folderIcon) ? (isOpen ? React__namespace.createElement(sandpackReact.DirectoryIconOpen, null) : React__namespace.createElement(sandpackReact.DirectoryIconClosed, null)) : IconPath(folderIcon);
        };
        var handleClickFile = function (data) { return clickFile(data); };
        var toggle = function () { setIsOpen(!isOpen); clickFile(row); };
        var onBlur = function () {
            setIsEdit(false);
            props.setAddFile(false);
            props.setAddFolder(false);
        };
        return (React__namespace.createElement("div", null, !hide &&
            React__namespace.createElement("div", { className: classNames('monaco-tree', [monacoTreeStyles, (isEdit || addNew) ? 'editing' : '']) }, !root && React__namespace.createElement(React__namespace.Fragment, null, React__namespace.createElement("div", { "data-active": activeFile === row.path, style: { paddingLeft: 12 * depth + "px" }, className: 'monaco-tree-row', onClick: toggle }, getIcon(), isEdit ?
                React__namespace.createElement(SingleInputForm, { isEdit: true, row: row, isFile: !isFolder, filename: row.name, currentPath: row.path, onBlur: setIsEdit }) :
                React__namespace.createElement("div", { className: "monaco-tree-name" }, row.name)), !row.readOnly && React__namespace.createElement("div", { className: "monaco-tree-actions" }, React__namespace.createElement(FileActions, { row: row, path: row.path, isFolder: isFolder, setIsEdit: setIsEdit }))), addNew && React__namespace.createElement("div", { className: 'monaco-tree-row', style: { paddingLeft: 12 * (depth + 1) + "px" } }, React__namespace.createElement("img", { className: "monaco-tree-icon", src: "https://cdn.jsdelivr.net/npm/material-icon-theme@3.7.1/icons/" + (props.addFile ? 'file' : 'folder-temp') + ".svg" }), React__namespace.createElement(SingleInputForm, { isEdit: false, isFile: props.addFile, filename: "", currentPath: row.path, row: row, onBlur: onBlur }))), (_c = row.content) === null || _c === void 0 ? void 0 :
            _c.map(function (x) {
                return React__namespace.createElement(MonacoFileTree, { activeFile: activeFile, key: x.name, row: x, depth: depth + 1, hide: !isOpen || hide, clickFile: handleClickFile, addFile: props.addFile, addFolder: props.addFolder, setAddFile: props.setAddFile, setAddFolder: props.setAddFolder });
            })));
    };

    function SandpackFileManager(_a) {
        var className = _a.className, props = __rest(_a, ["className"]);
        var _b = useSandbox(), sandbox = _b.sandbox, setFocusedNode = _b.setFocusedNode, tree = _b.tree;
        var clickFile = function (data) {
            setFocusedNode(data.content ? data : getParentNode(tree, data.path));
            if (!data.content) {
                sandbox.openFile(data.path);
            }
        };
        return (React__namespace.createElement(React__namespace.Fragment, null, tree.map(function (x) {
            return React__namespace.createElement(MonacoFileTree, { root: true, key: x.name, row: x, depth: 0, hide: false, clickFile: clickFile, activeFile: sandbox.activeFile, addFile: props.addFile, addFolder: props.addFolder, setAddFile: props.setAddFile, setAddFolder: props.setAddFolder });
        })));
    }
    ;

    var reactSelectStyles = {
        control: function (base) { return (Object.assign(Object.assign({}, base), { minHeight: '28px', minWidth: '150px', cursor: 'text' })); },
        dropdownIndicator: function (provided) { return (Object.assign(Object.assign({}, provided), { padding: '2px' })); },
        menuPortal: function (provided) { return (Object.assign(Object.assign({}, provided), { zIndex: 9999 })); },
    };
    var themes = [{ label: 'Light', value: 'light' }, { label: 'Dark', value: 'dark' }];
    function Settings() {
        var _a = useSandbox(), theme = _a.theme, setTheme = _a.setTheme;
        var classNames = sandpackReact.useClassNames();
        var _b = __read(React.useState(), 2), localTheme = _b[0], setLocalTheme = _b[1];
        React.useEffect(function () {
            var selectedTheme = themes.find(function (x) { return x.value === theme; });
            setLocalTheme(selectedTheme);
        }, [theme]);
        return React__default["default"].createElement("div", { className: classNames("navigation-settings", []) }, React__default["default"].createElement("div", { style: { display: 'flex', alignItems: 'center', justifyContent: 'space-between' } }, React__default["default"].createElement("h5", { style: { margin: 0 } }, "Themes"), React__default["default"].createElement(Select__default["default"], { className: "basic-single", classNamePrefix: "select", value: localTheme, isClearable: false, isSearchable: true, name: "color", options: themes, onChange: function (e) { return setTheme(e.value); }, styles: reactSelectStyles, menuPortalTarget: document.body })));
    }

    var collapseStyle = css({
        '.header-item': {
            minHeight: '$layout$headerHeight',
            paddingLeft: "12px",
            paddingRight: "12px",
            borderBottom: "1px solid $colors$surface2",
            borderTopCcolor: "$colors$surface2",
            borderRightCcolor: "$colors$surface2",
            borderLeftCcolor: "$colors$surface2",
            cursor: "pointer",
            display: 'flex',
            alignItems: 'center',
            '&__label': {
                display: 'flex',
                flex: 1,
                alignItems: 'center',
                '& svg': {
                    marginRight: '5px',
                    transition: 'transform 75ms ease 0s',
                    opacity: 0.25,
                },
            },
            '&__actions': {
                display: 'flex',
                alignItems: 'center',
                '&> :not(:last-child)': {
                    marginRight: '5px'
                }
            },
            userSelect: 'none'
        },
        '.container': {
            borderBottom: "1px solid $colors$surface2",
            borderTopColor: "$colors$surface2",
            borderRightColor: "$colors$surface2",
            borderLeftColor: "$colors$surface2",
            overflow: "auto",
            paddingTop: "16px",
            paddingBottom: "16px",
            opacity: 1,
            transition: "all 200ms ease 0s",
            paddingRight: "$space$3",
            paddingLeft: "$space$3",
        },
        '&.closed': {
            '.header-item': {
                '&__label': {
                    '& svg': {
                        transform: 'rotate(-90deg)'
                    }
                }
            },
            '.container': {
                borderBottom: "none $colors$surface2",
                overflow: "hidden",
                paddingTop: "0px",
                paddingBottom: "0px",
                opacity: 0,
            }
        }
    });
    var CollapsePanel = function (_a) {
        var title = _a.title, container = _a.container, _b = _a.action, action = _b === void 0 ? null : _b, _c = _a.panelOpen, panelOpen = _c === void 0 ? true : _c, _d = _a.alwaysShowAction, alwaysShowAction = _d === void 0 ? false : _d;
        var _e = __read(React.useState(panelOpen), 2), open = _e[0], setOpen = _e[1];
        var classNames = sandpackReact.useClassNames();
        return React__default["default"].createElement("section", { className: classNames("collapse " + (open ? '' : 'closed'), [collapseStyle]) }, React__default["default"].createElement("div", { className: 'header-item', onClick: function () { return setOpen(!open); } }, React__default["default"].createElement("div", { className: 'header-item__label' }, React__default["default"].createElement("svg", { width: "9", height: "6", viewBox: "0 0 9 6", xmlns: "http://www.w3.org/2000/svg" }, React__default["default"].createElement("path", { d: "M4.50009 6L-5.24537e-07 1.26364e-06L9 4.76837e-07L4.50009 6Z", fill: "currentcolor" })), React__default["default"].createElement("span", null, title)), (open || alwaysShowAction) && React__default["default"].createElement("div", { className: 'header-item__actions' }, action)), React__default["default"].createElement("div", { className: 'container' }, open ? container : ''));
    };
    function SandboxExplorer() {
        var _a = __read(React.useState(false), 2), addFile = _a[0], setAddFile = _a[1];
        var _b = __read(React.useState(false), 2), addFolder = _b[0], setAddFolder = _b[1];
        var props = useSandbox().props;
        return (React__default["default"].createElement(sandpackReact.SandpackStack, { style: { height: '100%', overflow: 'auto' } }, React__default["default"].createElement(CollapsePanel, { panelOpen: false, title: 'Settings', container: React__default["default"].createElement(Settings, null), alwaysShowAction: true }), React__default["default"].createElement(CollapsePanel, { title: 'Files', container: React__default["default"].createElement(SandpackFileManager, { addFile: addFile, addFolder: addFolder, setAddFile: setAddFile, setAddFolder: setAddFolder }), action: React__default["default"].createElement(FileManagerAction, { setAddFile: setAddFile, setAddFolder: setAddFolder }) }), !props.hideDependencies && !props.readOnly && React__default["default"].createElement(CollapsePanel, { panelOpen: false, title: 'Dependencies', container: React__default["default"].createElement(DependencyManager, null) })));
    }

    function SandboxPreview() {
        var classNames = sandpackReact.useClassNames();
        var _a = useSandbox(), sandbox = _a.sandbox, props = _a.props;
        var _b = __read(React.useState('40px'), 2), consoleWidth = _b[0], setConsoleWidth = _b[1];
        return (React__default["default"].createElement(Split__default["default"], { lineBar: true, mode: 'vertical', style: { width: '35%', zIndex: 1 } }, React__default["default"].createElement(sandpackReact.SandpackPreview, { style: { flex: 1, minHeight: 40 }, showNavigator: true, showOpenInCodeSandbox: false }), React__default["default"].createElement("div", { style: { minHeight: 40, height: consoleWidth }, className: classNames("console-container", [consoleContainerStyle]) }, React__default["default"].createElement("div", { className: 'console-tabs' }, React__default["default"].createElement("div", { className: 'console-tabs__tabs' }, React__default["default"].createElement("div", { className: 'console-tabs__tabs-label' }, " Console ")), React__default["default"].createElement("div", { className: 'console-tabs__actions' }, props.showRunBtn && React__default["default"].createElement("button", { onClick: function () { return sandbox.runCode(); }, className: classNames("action-buttons", [actionButtons, runButton, 'code-run']) }, "Run"), props.showSubmitBtn && React__default["default"].createElement("button", { onClick: function () { return sandbox.submitCode(); }, className: classNames("action-buttons", [actionButtons, submitButton, 'code-submit']) }, "Submit"))), React__default["default"].createElement("div", { className: 'console-view' }, React__default["default"].createElement(sandpackReact.SandpackConsole, { resetOnPreviewRestart: true })))));
    }

    var styles = css({
        height: '$layout$headerHeight',
        borderBottom: "1px solid $colors$surface2",
        background: "$colors$surface1",
        padding: '0 20px',
        justifyContent: 'space-between',
        alignItems: 'center',
        display: 'flex',
        '.toolbar-collapse button': {
            display: "flex",
            alignItems: "center",
            borderRadius: "4px",
            borderWidth: "0",
            background: "rgb(17, 109, 227)",
            color: "rgb(255, 255, 255)",
            cursor: "pointer",
            border: "1px solid transparent",
            fontSize: "12px",
            lineHeight: "15px",
            padding: 5
        },
        '.toolbar-fullscreen button': {
        // gap: "6px",
        // boxSizing: "border-box",
        // background: "rgb(17, 109, 227)",
        // whiteSpace: "nowrap",
        // fontWeight: 500
        },
        '.env-name': {
            display: 'flex',
            flexDirection: 'row',
            gap: 5,
            img: {
                width: '20px'
            },
            span: {
                lineHeight: '18px',
                fontSize: "$font$size",
                color: "$syntax$color$plain",
            }
        }
    });
    var Sandbox = function () {
        var _a, _b;
        var _c = useSandbox(), sandbox = _c.sandbox, theme = _c.theme, props = _c.props;
        var classNames = sandpackReact.useClassNames();
        var _d = __read(React.useState(false), 2), fullscreen = _d[0], setFullscreen = _d[1];
        var _e = __read(React.useState(250), 2), expWidth = _e[0], setExpWidth = _e[1];
        React.useEffect(function () {
            props.toggleFullscreen(fullscreen);
        }, [fullscreen]);
        var toggleFullscreen = function (event, value) {
            event === null || event === void 0 ? void 0 : event.stopPropagation();
            setFullscreen(value);
        };
        var toggleExplorer = function (event) {
            event === null || event === void 0 ? void 0 : event.stopPropagation();
            setExpWidth(function (prev) { return prev === 0 ? 250 : 0; });
        };
        return (React__default["default"].createElement(sandpackReact.SandpackProvider, { files: sandbox.files, theme: theme, options: { recompileDelay: 1000 }, customSetup: {}, style: { height: '100%', width: '100%', display: 'flex', flexDirection: 'column' } }, SandboxTemplates[props.environment] && React__default["default"].createElement("div", { className: classNames('sadbox-toolbar', [styles]) }, React__default["default"].createElement("div", { className: "toolbar-collapse" }), React__default["default"].createElement("div", { className: 'env-name' }, React__default["default"].createElement("img", { src: (_a = SandboxTemplates[props.environment]) === null || _a === void 0 ? void 0 : _a.icon }), React__default["default"].createElement("span", null, (_b = SandboxTemplates[props.environment]) === null || _b === void 0 ? void 0 : _b.dn)), React__default["default"].createElement("div", { className: "toolbar-fullscreen" }, React__default["default"].createElement(Tooltip__default["default"], { placement: "left", content: fullscreen ? 'Exit Fullscreen' : 'Enter Fullscreen', delay: 0 }, React__default["default"].createElement("button", { className: classNames('tabs__actions-item', [buttonClassName]), onClick: function (e) { return toggleFullscreen(e, !fullscreen); } }, fullscreen ? React__default["default"].createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "-2 -2 24 24", width: "14" }, React__default["default"].createElement("path", { fill: "currentColor", d: "M13 8h6c.6 0 1-.4 1-1s-.4-1-1-1h-3.6l4.3-4.3c.4-.4.4-1 0-1.4s-1-.4-1.4 0L14 4.6V1c0-.6-.4-1-1-1s-1 .4-1 1v6c0 .6.4 1 1 1zM7 0c-.6 0-1 .4-1 1v3.6L1.7.3C1.3-.1.7-.1.3.3s-.4 1 0 1.4L4.6 6H1c-.6 0-1 .4-1 1s.4 1 1 1h6c.6 0 1-.4 1-1V1c0-.6-.4-1-1-1zM20 13c0-.6-.4-1-1-1h-6c-.6 0-1 .4-1 1v6c0 .6.4 1 1 1s1-.4 1-1v-3.6l4.3 4.3c.2.2.5.3.7.3s.5-.1.7-.3c.4-.4.4-1 0-1.4L15.4 14H19c.6 0 1-.4 1-1zM7 12H1c-.6 0-1 .4-1 1s.4 1 1 1h3.6L.3 18.3c-.4.4-.4 1 0 1.4.2.2.4.3.7.3s.5-.1.7-.3L6 15.4V19c0 .6.4 1 1 1s1-.4 1-1v-6c0-.6-.4-1-1-1z" })) :
            React__default["default"].createElement("svg", { xmlns: "http://www.w3.org/2000/svg", viewBox: "-2 -2 24 24", width: "13", fill: "currentColor" }, React__default["default"].createElement("path", { d: "M19 0a1 1 0 0 1 1 1v6a1 1 0 0 1-2 0V3.414L11.414 10 18 16.586V13a1 1 0 0 1 2 0v6a1 1 0 0 1-1 1h-6a1 1 0 0 1 0-2h3.586L10 11.414 3.414 18H7a1 1 0 0 1 0 2H1a1 1 0 0 1-1-1v-6a1 1 0 0 1 2 0v3.586L8.586 10 2 3.414V7a1 1 0 1 1-2 0V1a1 1 0 0 1 1-1h6a1 1 0 1 1 0 2H3.414L10 8.586 16.586 2H13a1 1 0 0 1 0-2h6z" })))))), React__default["default"].createElement(Split__default["default"], { lineBar: true, style: { width: '100%' } }, React__default["default"].createElement(Split__default["default"], { lineBar: true, style: { flex: 1, width: '65%' }, visiable: expWidth !== 0 }, React__default["default"].createElement("div", { style: { width: expWidth, overflow: 'hidden', maxWidth: 350 } }, React__default["default"].createElement("div", { style: { minWidth: 250, height: '100%' } }, "  ", React__default["default"].createElement(SandboxExplorer, null))), React__default["default"].createElement("div", { style: { flex: 1, overflow: 'hidden' } }, " ", React__default["default"].createElement(SandboxEditor, null))), React__default["default"].createElement(SandboxPreview, null))));
    };
    function SandpackWrapper(props) {
        return React__default["default"].createElement(SandboxProvider, Object.assign({}, props), " ", React__default["default"].createElement(Sandbox, null), " ");
    }

    var ReactDirective = /** @class */ (function () {
        function ReactDirective(host) {
            this.host = host;
            this.root = client.createRoot(this.host.nativeElement);
        }
        ReactDirective.prototype.ngOnChanges = function () {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_b) {
                    this.root.render(React.createElement(this.component, this.props));
                    return [2 /*return*/];
                });
            });
        };
        ReactDirective.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this.root) === null || _a === void 0 ? void 0 : _a.unmount();
        };
        return ReactDirective;
    }());
    ReactDirective.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: ReactDirective, deps: [{ token: i0__namespace.ElementRef }], target: i0__namespace.ɵɵFactoryTarget.Directive });
    ReactDirective.ɵdir = i0__namespace.ɵɵngDeclareDirective({ minVersion: "12.0.0", version: "12.2.17", type: ReactDirective, selector: "[cjReact]", inputs: { component: "component", props: "props" }, usesOnChanges: true, ngImport: i0__namespace });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: ReactDirective, decorators: [{
                type: i0.Directive,
                args: [{
                        selector: '[cjReact]'
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ElementRef }]; }, propDecorators: { component: [{
                    type: i0.Input
                }], props: [{
                    type: i0.Input
                }] } });

    var SandpackComponent = /** @class */ (function () {
        function SandpackComponent(cd, dialog) {
            this.cd = cd;
            this.dialog = dialog;
            this.showRunBtn = true;
            this.showSubmitBtn = true;
            this.hideDependencies = false;
            this.readOnly = false;
            this.onFileChanges = new i0.EventEmitter();
            this.onSandboxMount = new i0.EventEmitter();
            this.afterRunCode = new i0.EventEmitter();
            this.afterSubmitCode = new i0.EventEmitter();
            this.component = SandpackWrapper;
            this.isFullscreen = false;
        }
        SandpackComponent.prototype.ngOnInit = function () {
            if (this.sandboxId) {
                this.setup();
            }
        };
        SandpackComponent.prototype.ngOnChanges = function (changes) {
            if (changes.sandboxId && !changes.sandboxId.firstChange) {
                this.props = null;
                if (this.sandboxId) {
                    this.setup();
                }
            }
            else if (this.sandboxId && !this.props && ((changes.files && !changes.files.firstChange) || (changes.templateUrl && !changes.templateUrl.firstChange))) {
                this.setup();
            }
        };
        SandpackComponent.prototype.setup = function () {
            if (this === null || this === void 0 ? void 0 : this.files) {
                this.setupSandbox();
            }
            else if (this === null || this === void 0 ? void 0 : this.templateUrl) {
                this.setupFiles();
            }
        };
        SandpackComponent.prototype.setupSandbox = function () {
            var _this = this;
            var _a;
            (_a = this.filesSubs) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            this.filesSubs = rxjs.timer(500).subscribe(function (res) {
                _this.props = {
                    files: _this.files,
                    sandboxId: _this.sandboxId || uuid.v4(),
                    showRunBtn: _this.showRunBtn,
                    showSubmitBtn: _this.showSubmitBtn,
                    onFileChanges: function (files) { _this.files = files; setTimeout(function () { return _this.onFileChanges.next(_this.files); }, 500); },
                    onRunCode: function (files) { return _this.executeCode(files, 'RUN'); },
                    onSubmitCode: function (files) { return _this.executeCode(files, 'SUBMIT'); },
                    onSandboxMount: function (context) { return _this.onSandboxMount.emit(context); },
                    toggleFullscreen: function (isFullscreen) { return _this.toggleFullscreen(isFullscreen); },
                    environment: _this.environment,
                    hideDependencies: _this.hideDependencies,
                    readOnly: _this.readOnly
                };
            });
        };
        SandpackComponent.prototype.setupFiles = function () {
            var _this = this;
            var _a;
            (_a = this.filesSubs) === null || _a === void 0 ? void 0 : _a.unsubscribe();
            this.filesSubs = fetchFromUrl(this.templateUrl).subscribe(function (res) {
                _this.files = _this.cleanUpData(res);
                _this.setupSandbox();
            });
        };
        SandpackComponent.prototype.cleanUpData = function (data) {
            data = lodash.pickBy(data, function (value, key) { return !lodash.isEmpty(value); });
            data = lodash.mapKeys(data, function (value, key) { return key.startsWith('/') ? key : "/" + key; });
            return lodash.isEmpty(data) ? null : data;
        };
        SandpackComponent.prototype.executeCode = function (files, type) {
            var _this = this;
            this.openDialog({ type: type, files: files }).subscribe(function (res) { return type === 'RUN' ? _this.afterRunCode.emit(res) : _this.afterSubmitCode.emit(res); });
        };
        ;
        SandpackComponent.prototype.ngOnDestroy = function () {
            var _a;
            (_a = this.filesSubs) === null || _a === void 0 ? void 0 : _a.unsubscribe();
        };
        SandpackComponent.prototype.openDialog = function (data) {
            return this.dialog.open(CodeSubmissionComponent, {
                panelClass: 'code-submission-panel',
                maxWidth: '950px',
                minWidth: '35vw',
                maxHeight: '80vh',
                minHeight: '230px',
                autoFocus: false,
                data: Object.assign(Object.assign({}, data), { user_type: this.user_type, portal: this.portal, test_type: this.test_type, test_uuid: this.test_uuid, question: this.question, language_id: this.language_id }),
                disableClose: true
            })
                .afterClosed().pipe(operators.take(1));
        };
        SandpackComponent.prototype.toggleFullscreen = function (isFullscreen) {
            this.isFullscreen = isFullscreen;
            this.cd.markForCheck();
        };
        return SandpackComponent;
    }());
    SandpackComponent.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackComponent, deps: [{ token: i0__namespace.ChangeDetectorRef }, { token: i2__namespace.MatDialog }], target: i0__namespace.ɵɵFactoryTarget.Component });
    SandpackComponent.ɵcmp = i0__namespace.ɵɵngDeclareComponent({ minVersion: "12.0.0", version: "12.2.17", type: SandpackComponent, selector: "cj-sandpack", inputs: { files: "files", templateUrl: "templateUrl", sandboxId: "sandboxId", portal: "portal", user_type: "user_type", test_uuid: "test_uuid", test_type: "test_type", language_id: "language_id", question: "question", showRunBtn: "showRunBtn", showSubmitBtn: "showSubmitBtn", environment: "environment", hideDependencies: "hideDependencies", readOnly: "readOnly" }, outputs: { onFileChanges: "onFileChanges", onSandboxMount: "onSandboxMount", afterRunCode: "afterRunCode", afterSubmitCode: "afterSubmitCode" }, usesOnChanges: true, ngImport: i0__namespace, template: "<div class=\"sandpack-main-ide\" [ngClass]=\"{'fullscreen': isFullscreen}\">\n    <div *ngIf=\"props?.files\" style=\"height: 100%;width: 100%;\" cjReact [component]=\"component\" [props]=\"props\"></div>\n    <div *ngIf=\"!props?.files\" style=\"height: 100%;display: flex;align-items: center;justify-content: center;\">\n        <mat-spinner [diameter]=\"30\"></mat-spinner>\n    </div>\n</div>", styles: [".sandpack-main-ide{border:1px solid #d1d1d1!important;border-radius:4px;height:100%;width:100%}.sandpack-main-ide.fullscreen{position:fixed;top:0;left:0;z-index:99;right:0}\n"], components: [{ type: i2__namespace$1.MatSpinner, selector: "mat-spinner", inputs: ["color"] }], directives: [{ type: i7__namespace.NgClass, selector: "[ngClass]", inputs: ["class", "ngClass"] }, { type: i7__namespace.NgIf, selector: "[ngIf]", inputs: ["ngIf", "ngIfThen", "ngIfElse"] }, { type: ReactDirective, selector: "[cjReact]", inputs: ["component", "props"] }] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackComponent, decorators: [{
                type: i0.Component,
                args: [{
                        selector: 'cj-sandpack',
                        templateUrl: './sandpack.component.html',
                        styleUrls: ['./sandpack.component.scss'],
                    }]
            }], ctorParameters: function () { return [{ type: i0__namespace.ChangeDetectorRef }, { type: i2__namespace.MatDialog }]; }, propDecorators: { files: [{
                    type: i0.Input
                }], templateUrl: [{
                    type: i0.Input
                }], sandboxId: [{
                    type: i0.Input
                }], portal: [{
                    type: i0.Input
                }], user_type: [{
                    type: i0.Input
                }], test_uuid: [{
                    type: i0.Input
                }], test_type: [{
                    type: i0.Input
                }], language_id: [{
                    type: i0.Input
                }], question: [{
                    type: i0.Input
                }], showRunBtn: [{
                    type: i0.Input
                }], showSubmitBtn: [{
                    type: i0.Input
                }], environment: [{
                    type: i0.Input
                }], hideDependencies: [{
                    type: i0.Input
                }], readOnly: [{
                    type: i0.Input
                }], onFileChanges: [{
                    type: i0.Output
                }], onSandboxMount: [{
                    type: i0.Output
                }], afterRunCode: [{
                    type: i0.Output
                }], afterSubmitCode: [{
                    type: i0.Output
                }] } });

    var DirectivesModule = /** @class */ (function () {
        function DirectivesModule() {
        }
        return DirectivesModule;
    }());
    DirectivesModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: DirectivesModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    DirectivesModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: DirectivesModule, declarations: [ReactDirective], imports: [i7.CommonModule], exports: [ReactDirective] });
    DirectivesModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: DirectivesModule, imports: [[
                i7.CommonModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: DirectivesModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            ReactDirective
                        ],
                        imports: [
                            i7.CommonModule
                        ],
                        exports: [ReactDirective]
                    }]
            }] });

    var PopupsModule = /** @class */ (function () {
        function PopupsModule() {
        }
        return PopupsModule;
    }());
    PopupsModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: PopupsModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    PopupsModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: PopupsModule, declarations: [CodeSubmissionComponent], imports: [i7.CommonModule,
            i5.MatProgressBarModule,
            i4.MatIconModule,
            i3.MatButtonModule,
            i6.MatTableModule,
            i8.MatTooltipModule] });
    PopupsModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: PopupsModule, imports: [[
                i7.CommonModule,
                i5.MatProgressBarModule,
                i4.MatIconModule,
                i3.MatButtonModule,
                i6.MatTableModule,
                i8.MatTooltipModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: PopupsModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            CodeSubmissionComponent
                        ],
                        imports: [
                            i7.CommonModule,
                            i5.MatProgressBarModule,
                            i4.MatIconModule,
                            i3.MatButtonModule,
                            i6.MatTableModule,
                            i8.MatTooltipModule
                        ]
                    }]
            }] });

    var SandpackModule = /** @class */ (function () {
        function SandpackModule() {
        }
        return SandpackModule;
    }());
    SandpackModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    SandpackModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackModule, declarations: [SandpackComponent], imports: [i7.CommonModule,
            DirectivesModule,
            PopupsModule,
            i2$1.MatProgressSpinnerModule,
            i2.MatDialogModule], exports: [SandpackComponent] });
    SandpackModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackModule, imports: [[
                i7.CommonModule,
                DirectivesModule,
                PopupsModule,
                i2$1.MatProgressSpinnerModule,
                i2.MatDialogModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: SandpackModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [
                            SandpackComponent
                        ],
                        imports: [
                            i7.CommonModule,
                            DirectivesModule,
                            PopupsModule,
                            i2$1.MatProgressSpinnerModule,
                            i2.MatDialogModule
                        ],
                        exports: [SandpackComponent]
                    }]
            }] });

    var CodejudgeModule = /** @class */ (function () {
        function CodejudgeModule() {
        }
        CodejudgeModule.forRoot = function (configuration) {
            configuration = this.transformConfigurations(configuration);
            AWS.initialize(configuration);
            return {
                ngModule: CodejudgeModule,
                providers: [{ provide: 'environment', useValue: configuration }]
            };
        };
        CodejudgeModule.transformConfigurations = function (configuration) {
            var _a, _b, _c;
            return Object.assign(Object.assign({}, configuration), { coreApiUrl: (_a = configuration.coreApiUrl) !== null && _a !== void 0 ? _a : configuration.host0, recruitApiUrl: (_b = configuration.apiUrl) !== null && _b !== void 0 ? _b : configuration.host2, developerApiUrl: (_c = configuration.developerApiUrl) !== null && _c !== void 0 ? _c : configuration.host1 });
        };
        return CodejudgeModule;
    }());
    CodejudgeModule.ɵfac = i0__namespace.ɵɵngDeclareFactory({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodejudgeModule, deps: [], target: i0__namespace.ɵɵFactoryTarget.NgModule });
    CodejudgeModule.ɵmod = i0__namespace.ɵɵngDeclareNgModule({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodejudgeModule, imports: [i1.HttpClientModule] });
    CodejudgeModule.ɵinj = i0__namespace.ɵɵngDeclareInjector({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodejudgeModule, imports: [[
                i1.HttpClientModule
            ]] });
    i0__namespace.ɵɵngDeclareClassMetadata({ minVersion: "12.0.0", version: "12.2.17", ngImport: i0__namespace, type: CodejudgeModule, decorators: [{
                type: i0.NgModule,
                args: [{
                        declarations: [],
                        imports: [
                            i1.HttpClientModule
                        ],
                    }]
            }], ctorParameters: function () { return []; } });

    /*
     * Public API Surface of Codejudge
     */

    /**
     * Generated bundle index. Do not edit.
     */

    exports.AWS = AWS;
    exports.CodejudgeModule = CodejudgeModule;
    exports.DirectivesModule = DirectivesModule;
    exports.PORTAL = PORTAL;
    exports.ReactDirective = ReactDirective;
    exports.SandboxTemplates = SandboxTemplates;
    exports.SandpackComponent = SandpackComponent;
    exports.SandpackModule = SandpackModule;
    exports.USER_TYPE = USER_TYPE;
    exports.fetchFromUrl = fetchFromUrl;
    exports.pollWhile = pollWhile;
    exports.resolvablePromise = resolvablePromise;
    exports.runInZone = runInZone;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=opencoders-codejudge.umd.js.map
