import { Observable } from 'rxjs';
export interface S3UploadOptions {
    file: File | Blob | string;
    path: string;
    name: string;
    unique?: boolean;
    root?: boolean;
}
export interface S3UploadResult {
    url: string;
    fileName: string;
}
export declare class AWS {
    private static s3Client;
    private static environment;
    static initialize(environment: any): void;
    static uploadFiles(options: S3UploadOptions[]): Observable<S3UploadResult[]>;
    static uploadFile(options: S3UploadOptions): Observable<S3UploadResult>;
}
